/********************************************************
 * File: file.c
 * Created at Sun Jan 28 22:10:26 MSK 2001 by raorn // raorn@binec.ru
 * Miscellaneous suff
 * $Id: file.c,v 1.2 2003/07/17 04:24:21 lmike Exp $
 *******************************************************/
#include <machine/defs.h>

#ifdef HAVE_SYS_STAT_H
# include <sys/stat.h>
#endif
#include <sys/types.h>
#include <stdio.h>
#include <string.h>
#include <signal.h>
#ifdef HAVE_ERRNO_H
# include <errno.h>
#endif
#ifdef HAVE_FCNTL_H
#include <fcntl.h>
#endif
#ifdef HAVE_UNISTD_H
# include <unistd.h>
#endif

#include "file.h"
#include "mystrncpy.h"

bool Exists(uchar * file)
{
  struct stat st;

  if (stat(file, &st) == 0)
    return (TRUE);

  return (FALSE);
}

bool Lock(uchar * basename, bool bylink, bool usepid)
{
  uchar buf[CE_PATHMAX], buf2[CE_PATHMAX];
  FILE *fp;
  long pid=0;
  int rc;

  snprintf(buf, CE_PATHMAX-1, "%s.bsy", basename);

  if ((fp = fopen(buf, "rt"))) {
    if (usepid) {
      rc=fscanf(fp, "%ld", &pid);
      fclose(fp);
      if (rc!=1) /* fscanf failed to parse input stream */
         return FALSE;
      if (kill(pid, 0) && errno == ESRCH)
        unlink(buf);
      else
        return FALSE;
    } else {
      fclose(fp);
      return FALSE;
    }
  }

  if (bylink) {
    rc=strlen(basename);
    if (rc>=CE_PATHMAX)
       return FALSE;
    mystrncpy(buf2, basename, rc);
    snprintf(buf2+rc, CE_PATHMAX-rc-1, ".%ld", (long) getpid());
    if (!(fp = fopen(buf2, "wt")))
      return FALSE;
    if (usepid)
      fprintf(fp, "%10ld\n", (long) getpid());
    fclose(fp);
#ifdef __MINGW32__
    rc = rename(buf2, buf);
#else
    rc = link(buf2, buf);
    unlink(buf2);
#endif
    if (rc)
      return FALSE;
  } else {
    if ((rc = open(buf, O_WRONLY|O_CREAT|O_EXCL, 0644)) < 0)
      return FALSE;
    if (usepid) {
      snprintf(buf2, CE_PATHMAX, "%10ld\n", (long)getpid());
      write(rc, buf2, strlen(buf2));
    }
    close(rc);
  }

  return TRUE;
}

void Unlock(uchar * basename)
{
  uchar buf[CE_PATHMAX];

  snprintf(buf, CE_PATHMAX-1, "%s.bsy", basename);

  unlink(buf);
}
