/********************************************************
 * File: crashecho.h
 * Created at Sun Jan 28 22:10:29 MSK 2001 by raorn // raorn@binec.ru
 *
 * $Id: crashecho.h,v 1.1.1.1 2002/10/28 19:55:19 raorn Exp $
 *******************************************************/
#include <machine/defs.h>

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <signal.h>
#ifdef HAVE_ERRNO_H
# include <errno.h>
#endif
#include <sys/stat.h>
#include <sys/types.h>
#ifdef HAVE_FCNTL_H
#include <fcntl.h>
#endif

#include <shared/jblist.h>
#include <shared/mystrncpy.h>
#include <shared/jbstrcpy.h>
#include <shared/path.h>
#include <shared/node4d.h>
#include <shared/jbdir.h>
#include <shared/pattern.h>
#include <shared/file.h>
#include <shared/exec.h>
#include <shared/logwrite.h>

#include <shared/fidonet.h>
#include <shared/storedmsg.h>

#include "node2dpat.h"
#include "mb.h"
#include "memmessage.h"
#include "cfg.h"
#include "memmessage.h"
#include "dupe.h"
#include "stats.h"
#include "misc.h"
#include "toss.h"
#include "scan.h"
#include "pkt.h"
#include "handle.h"
#include "outbound.h"
#include "areafix.h"

extern struct jbList PktList;

extern bool nomem;
extern bool ioerror;
extern bool exitprg;

extern ulong ioerrornum;

extern ulong toss_total;
extern ulong toss_bad;
extern ulong toss_import;
extern ulong toss_written;
extern ulong toss_dupes;
extern ulong toss_cc;

extern ulong scan_total;
extern ulong rescan_total;

#define DOING_NONE      0
#define DOING_TOSS      1
#define DOING_TOSSBAD   2
#define DOING_SCAN      3
#define DOING_AFIX      4
#define DOING_RESCAN    5

extern int nowdoing;

extern bool no_security;

extern struct ConfigNode *RescanNode;

extern ulong DayStatsWritten;

extern struct Nodelist AvailNodelists[];
extern struct Messagebase AvailMessagebases[];

extern struct Config config;

extern bool ctrlc;

bool BeforeScanToss(void);
void AfterScanToss(bool success);

extern uchar *prinames[];
