#-*- sh -*-
# Configuration file for ifmail package by Eugene Crosser
# Compile-time default name of this file may be overridden by -I key.

# Lines with the first nonblank character '#' are comments.

# Log file name. Overrides compile-time default.
logfile		_LOGDIR_/iflog

# Debug file name. Overrides compile-time default.
debugfile	_LOGDIR_/ifdebug

# Debugging verbosity (is overidden by -x key). Default is 0.
verbose		0

# Main address:
address		2:5020/230@fidonet

# AKAs:
address		2:5020/6.14@fidonet

# Passwords for nodes. Not checked by iftoss (unless -DPARANOID specified
# at compile-time), checked by ifcico.
# Inserted into outgoing mail packets, EMSI and yoohoo packets.
password	2:5929/6	QWERY

# Include config extention file (here: file with real passwords).
# Includes may be nested. If the nesting is cyclic, the program cycles too.
# You are warned.
# include		/etc/ifmail/passwd

# This host fully qualified domain name to add to the alias above
myfqdn		_HOSTNAME_

# If this is specified, beginning of the fidonet message will be scaned
# for RFC looking headers _only_ if the message is addresses to the name
# specified.  If not specified, beginning of all message is scaned.  I
# do not recommend specifying magicname unless you know that parsing
# headers will really break things.
# magicname	UUCP

# Directory for incoming packets/files:
inbound		/var/spool/ftn/inb
# Directories for "listed" and "protected" sessions
listinbound	/var/spool/ftn/inb
protinbound	/var/spool/ftn/pin

# Directory for outgoing packets (default domain and zone):
# other zones will be like "/usr/spool/ifmail/outb.003",
# other domains will be like "/usr/spool/ifmail/<domain>.<zone>"
outbound	/var/spool/ftn/outb

# If you specify this, outgoing arcmail files will go to `outbound',
# but be reffered as being in `dosoutbound' in the .flo files
#dosoutbound    h:\spool\ifmail\outb

# Primary nodelist (serves "outbound" directory and domain from the
# first "address" statement). Name expanded with ".NNN" if neccessary.
nodelist	/var/spool/ftn/nl.d/nodelist

# Secondary nodelists and nodelists for other domains.
# use directory name from the first "nodelist" statement.
#		filename	originating address
#nodelist	pnt5020.ndl	2:5020/0@fidonet
#nodelist	chatlist	100:0/0@chateaunet
nodelist	private.ndl	2:5020/0@fidonet

# domain translations, just context substitution.  Leading dot recommended.
# May contain '@'-sign too.  First matching used.
# NOTE: If you specify at least one domtrans line, there will be _NO_
# default for fidonet <--> fidonet.org.  Don't forget to specify it
# explicitly as a last line.
#		FTN side		Internet side
domtrans	.n5020.z2.fidonet	.fido.pccross.msk.su
domtrans	.n5030.z2.fidonet	.fido.tctube.spb.su
domtrans	.fidonet		.fidonet.org

# Automatically updated alias database.  If omitted or inaccessible,
# ^aREPLYADDR and ^aREPLYTO kludges are generated in fido messages.
database	_IFMAILDIR_/ifdbm

# Sequencer file (used to generate unique IDs)
sequencer	_IFMAILDIR_/seq

# Areas file (format: "AREA newsgroup distribution")
areas		_ETCDIR_/Areas

# Bad groups prefixes - do not pass to fido if appear in Newsgroups header
# This is NOT the same as "!news.group" in the cnews "sys" file.
badgroup	relcom.ads.
badgroup	relcom.commerce.

# Maximum allowed number of groups in the Newsgroups header, article will
# not be gated if exeeds.  If zero or omitted - no limit.
maxgroups	5

# Character translation tables.  The format of the files is as follows:
#
# <orig.char> <whitespace> <dest.char>
#
# (one character in a line).  <orig.char> and <dest.char> can be specified
# in one of four notation styles:
# - character itself in single quotes (e.g. 'a')
# - decimal number (e.g. 123)
# - octal number (e.g. 0123)
# - hexadecimal number (e.g. 0x7f)
#
# Crosshatch ('#') denotes start of comment; space, tab and crosshatch
# characters cannot be specified using the first (character) notation.
#
# Internet -> FidoNet (outgoing) character mapping table (a la mapchan)
outtab		_SHAREDIR_/outkoi8alt
# FidoNet -> Internet (incoming) character mapping table
intab		_SHAREDIR_/outaltkoi8

# Delimiter char into user name for replace to space (default '.').
dots	_

# "From:" first line in _body_ message ( Internet -> FidoNet ).
# Default - Yes
bodyfrom No

## Strip seen-by kludge
## Default - Yes
strip_seenby Yes

## Autocreate
useautocreate Yes
autocreatecmd /usr/lib/news/bin/ctlinnd newgroup %s
autocreateprefix fido.
# Use User-Agent, X-Mailer etc flags for tearline
usereadername Yes
# Add TID kludge for exported messages
usetid Yes

## Address format for mails gated by IFgate
##  1  - user@domain (Username)
##  2  - Username <user@domain>
addrfmttype 1

# Transport programs for mail and news, used by iftoss
# for sendmail, $F expands to "from" address, $T - to "to" address.
sendmail	/usr/sbin/sendmail $T
rnews		/usr/bin/rnews

# Toss program, used by ifunpack
iftoss		_BINDIR_/iftoss

# Unpackers, used by ifunpack. 
# $F expands to archieve file name
unzip		/usr/bin/unzip -ojq $F
unarj		/usr/bin/unarj e $F
unarc		/usr/bin/unpack $F
unzoo		/usr/bin/zoo -extract $F

# Packer program, used by ifpack
# $F expands to archieve file name, $P - to list of packet names
packer		/usr/bin/zip $F $P

# Maximum arcmail file size, ifpack will start new arcmail file if exceeds
maxfsize	500000

# Maximum packet size, ifmail/ifnews will start new packet if exeeds.
# *.?ut files are NOT created if nonzero specified, you must run ifpack
# to make packets go out.
maxpsize	30000

# Maximum message size when splitting big messages of usenet origin
# default is 12300 bytes
maxmsize 12300

# Flavors that should not be subject to packet size limiting.  These
# flavors will be put into `ready to send' packets and not packed
# by ifpack.  Special flavor 'm' means "all netmail".
nonpacked	cm

# cnews log file and (temporary) database for seen-bys
newslog		_LOGDIR_/news-log
msgidbm		/tmp/ifmsgids
#
