#include <stdlib.h>
#include <stdio.h>
#include <limits.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include "xutil.h"
#include "lutil.h"
#include "ftn.h"
#include "ftnmsg.h"
#include "rfcmsg.h"
#include "config.h"
#include "strings.h"
#include "version.h"
#include "hash.h"

#ifndef ULONG_MAX
#define ULONG_MAX 4294967295
#endif

int newsmode=0;
char *replyaddr=NULL;

extern time_t now;
extern faddr *bestaka;

extern time_t parsedate(char *,void *);
extern int registrate(char *,char *);
extern unsigned long atoul(char*);

extern unsigned INT16 crc(char *);
extern int flagset(char *);

#ifdef DECODE_HEADERS
void convert_header_7bit_to_8bit(char *s)
{
#define DECODE_HEX(x) (isdigit(x)!=0?((x)-48):(((x)&0xDF)-55))
	
/* static const char BASE64_ALPHABET[]="ABCDEFGHIJKLMNOPQRSTUVWXYZ"
                                     "abcdefghijklmnopqrstuvwxyz"
                                     "0123456789+/"; */

	static const char UNBASE64_ALPHABET[]={"\x3E\xFF\xFF\xFF\x3F"
					    "\x34\x35\x36\x37\x38"
	    				    "\x39\x3A\x3B\x3C\x3D"
					    "\xFF\xFF\xFF\x00\xFF\xFF\xFF"
					    "\x00\x01\x02\x03\x04"
					    "\x05\x06\x07\x08\x09"
					    "\x0A\x0B\x0C\x0D\x0E"
			            "\x0F\x10\x11\x12\x13"
					    "\x14\x15\x16\x17\x18\x19"
					    "\xFF\xFF\xFF\xFF\xFF\xFF"
					    "\x1A\x1B\x1C\x1D\x1E"
					    "\x1F\x20\x21\x22\x23"
					    "\x24\x25\x26\x27\x28"
					    "\x29\x2A\x2B\x2C\x2D"
					    "\x2E\x2F\x30\x31\x32\x33"};
	char *p=s, *p1;
	char ts[10];
	int i,j;

	while ( s[0]!=0 )
		{
			if ( s[0]=='=' && s[1]=='?' && strlen(s)>=14 )
				{
					strncpy(ts, s, 9); ts[9]=0; i=0;
					while ( ts[i]!=0 )
						{if ( ts[i]>64 && ts[i]<91 ) ts[i]|=0x20; i++;}
			
					if ( strcmp(ts, "=?koi8-r?")==0 )
						{
							ts[0]=s[9]; s+=11;

							if ( (ts[0]|0x20)=='q' )
								{
									/* decode quote-printable */
									
									while ( (*s)!=0 && (*s)!='?' )
										{
											if ( ((*s)=='=' && s[1]!=0)
												 &&
												 (isxdigit(s[1])!=0 && isxdigit(s[2])!=0) )
												{
													(*p)=(DECODE_HEX(s[1])<<4)+DECODE_HEX(s[2]);
													s+=2;
												}
											else
												if ( (*s)=='_' )
													(*p)=' ';
												else
													(*p)=(*s);
											
											p++; s++;
										}
								}
							else 
								if ( (ts[0]|0x20)=='b' )
									{
								/* decode base64 */
										
										union
										{
											char items[4];
											long all;
										} base64_packet;
										char unbase64_data[3];
										
										i=j=0; base64_packet.all=0;
										while ( (*s)!=0 && (*s)!='?' )
											{
												if ( (*s)>43 && (*s)<123 && UNBASE64_ALPHABET[(*s)-43]!=((char)-1) )
													{
														base64_packet.items[i]=UNBASE64_ALPHABET[(*s)-43];
														
														if ( (*s)=='=' ) j++;
												
														if ( i==3 )
															{
																unbase64_data[0]=(base64_packet.items[0]<<2)|
																	(base64_packet.items[1]>>4);
																unbase64_data[1]=(base64_packet.items[1]<<4)|
																	(base64_packet.items[2]>>2);
																unbase64_data[2]=(base64_packet.items[2]<<6)|
																	(base64_packet.items[3]);
																
																j=3-j;
																for (i=0;i<j;i++) {(*p)=unbase64_data[i]; p++;}
																
																i=j=0; base64_packet.all=0;
															}
														else
															i++;
													}
												else
													{
														(*p)=(*s);
														p++;
													}
												
												s++;
											}
									}
							
							if ( s[0]=='?' && s[1]=='=' )
								{
									s+=2;
								}
						}
					else
						{/*  =?koi8r? -   */
							*p=*s; s++; p++;
						}
				}
			else
				{
					if ( s[0]=='\n' && (s[1]=='\t' || s[1]==' ')) /*     */
						{
							s+=2;
						}
					else
						{
							*p=*s; s++; p++;
						}
				}
		}
    *p=0;
}
#endif

int ftnmsgid(msgid,s,n)
char *msgid;
char **s;
unsigned long *n;
{
	char *buf,*l,*r,*p;
	unsigned long nid=0L;
	faddr *tmp;
	int ftnorigin=0;

	if (msgid == NULL)
	{
		*s=NULL;
		*n=0L;
		return ftnorigin;
	}

	buf=xmalloc(strlen(msgid)+65);
	strcpy(buf,msgid);
	if ((l=strchr(buf,'<'))) l++;
	else l=buf;
	while (isspace(*l)) l++;
	if ((r=strchr(l,'>'))) *r='\0';
	r=l+strlen(l)-1;
	while (isspace(*r) && (r > l)) (*r--)='\0';
#ifdef FTN_MSGID
	if ((tmp=parsefaddr_ftn_msgid(l)))
#else
	if ((tmp=parsefaddr(l)))
#endif
	{
		if (tmp->name)
		{
			if (strspn(tmp->name,"0123456789") == strlen(tmp->name))
				nid=atoul(tmp->name);
			else nid=ULONG_MAX;
			if (nid == ULONG_MAX)
				hash_update_s(&nid,tmp->name);
			else
				ftnorigin=1;
		}
		else
		{
			hash_update_s(&nid,l);
		}
#ifdef FTN_MSGID
		*s=xstrcpy(ascfnode_ftn_msgid(tmp,0x1f));
#else
		*s=xstrcpy(ascfnode(tmp,0x1f));
#endif
		tidy_faddr(tmp);
	}
	else
	{
		if ((r=strchr(l,'@')) == NULL) /* should never happen */
		{
			*s=xstrcpy(l);
			hash_update_s(&nid,l);
		}
		else
		{
			*r='\0';
			if ((p=strchr(l,'%')))
			{
				*p='\0';
				if (strspn(l,"0123456789") == strlen(l))
				{
					*r='@';
					r=p;
				}
				else *p='%';
			}
			r++;
			if (strspn(l,"0123456789") == strlen(l))
				nid=atoul(l);
			else nid=ULONG_MAX;
			if (nid == ULONG_MAX) {
				hash_update_s(&nid,l);
			}
			if (strchr(r,'@'))
			{
				*s=xmalloc(strlen(r)+3);
				sprintf(*s,"<%s>",r);
			}
			else *s=xstrcpy(r);
		}
	}
	*n=nid;

	free(buf);
	return ftnorigin;
}

ftnmsg *mkftnhdr(msg)
rfcmsg *msg;
{
	char *freename=NULL,*rfcfrom=NULL,*p,*l,*r;
	ftnmsg *tmsg;
	fromname *from;
	int needreplyaddr;
	char *addrfmt="%s (%s)";
	int size;
	tmsg=(ftnmsg *)xmalloc(sizeof(ftnmsg));

	tmsg->flags=0;
	tmsg->ftnorigin=0;
	tmsg->to=NULL;
	tmsg->from=NULL;
	tmsg->date=0L;
	tmsg->subj=NULL;
	tmsg->isftn=0;
	tmsg->rfcfrom=NULL;
	tmsg->msgid_s=NULL;
	tmsg->msgid_a=NULL;
	tmsg->reply_s=NULL;
	tmsg->reply_a=NULL;
	tmsg->origin=NULL;
	tmsg->area=NULL;

	if (newsmode)
	{
	     p=xstrcpy(hdr("Comment-To",msg));
	     if (p == NULL) p=xstrcpy(hdr("X-Comment-To",msg));
	     if (p == NULL) p=xstrcpy(hdr("X-FTN-To",msg));
	     if (p == NULL) p=xstrcpy(hdr("X-Fidonet-Comment-To",msg));
	     if (p == NULL) p=xstrcpy(hdr("X-Apparently-To",msg));
	     if (p)
	     {
		  debug(6,"getting `to' address from: \"%s\"",p);
		  if ((tmsg->to=parsefaddr(p)) == NULL)
		  {
		       tmsg->to=parsefaddr("All@p0.f0.n0.z0");
		       if ((l=strrchr(p,'<')) && (r=strchr(p,'>')) && (l < r))
		       {
			    r=l;
			    *r--='\0';
			    while (isspace(*r)) *r--='\0';
			    l=p;
			    while (isspace(*l)) l++;
		       }
		       else if ((l=strrchr(p,'(')) && (r=strchr(p,')')) && 
				(l < r))
		       {
			    *r--='\0';
			    while (isspace(*r)) *r--='\0';
			    l++;
			    while (isspace(*l)) l++;
		       }
		       else
		       {
			    l=p;
			    while (isspace(*l)) l++;
			    r=p+strlen(p)-1;
			    if (*r == '\n') *r--='\0';
			    while (isspace(*r)) *r--='\0';
		       }
		       
		       if(*l)
		       {
			    if (strlen(l) > MAXNAME)
				 l[MAXNAME]='\0';
			    free(tmsg->to->name);
			    tmsg->to->name=xstrcpy(l);
		       }
		  }
		  free(p);
	     }
	     else
		  tmsg->to=parsefaddr("All@p0.f0.n0.z0");
	     if test_verbose(3) debug(3,"TO: %s",ascinode(tmsg->to,0x7f));
	}
	
	p=hdr("From",msg);
	debug(9, "key: %s\n",msg);
	from=convertfrom(p);
	rfcfrom=from->email;
	freename=from->name;
	strip_crlf(rfcfrom);
	strip_crlf(freename);
	if (freename)
	{
	     if ((*freename == '\"') &&
		 (*(p=freename+strlen(freename)-1) == '\"'))
	     {
		  freename++;
		  *p='\0';
	     }
	}
	if (*freename == '\0') freename=rfcfrom;

#ifdef DECODE_HEADERS
	convert_header_7bit_to_8bit(freename);
#endif
	     
	     if (newsmode)
		  debug(3,"FROM: %s <%s>",freename,rfcfrom);
	     else
		  loginf("from: %s <%s>",freename,rfcfrom);
	     needreplyaddr=1;
	     if ((tmsg->from=parsefaddr(rfcfrom)) == NULL)
	     {
		  if (freename && rfcfrom)
		       if (!strchr(freename,'@') && 
			   !strchr(freename,'%') && 
			   strncasecmp(freename,rfcfrom,MAXNAME))
		       {
//			    needreplyaddr=registrate(freename,rfcfrom);
			    needreplyaddr=1;
		       }
	     }
	     else
	     {
		  tmsg->ftnorigin=1;
	     }
	     
	     if (replyaddr)
	     {
	     free(replyaddr);
	     replyaddr=NULL;
	     }
	     if (needreplyaddr && (tmsg->from == NULL))
	     {	     
		  debug(6,"fill replyaddr with \"%s\"",rfcfrom);
		  tmsg->isftn=1;
		  size=strlen(rfcfrom)+strlen(freename)+strlen(addrfmt);
		  tmsg->rfcfrom=xmalloc(size);
		  if(!strcasecmp(addrfmttype, "1"))
		       sprintf(tmsg->rfcfrom, addrfmt, rfcfrom ,freename);
		  else {
		       addrfmt="%s <%s>";
		       sprintf(tmsg->rfcfrom, addrfmt, freename, rfcfrom);
		  }
		  replyaddr=tmsg->rfcfrom;
	     }
	     
	     debug(6,"From address was%s distinguished as ftn",
		   tmsg->from ? "" : " not");
	
	     if ((tmsg->from == NULL) && (bestaka))
	     {
		  tmsg->from=(faddr *)xmalloc(sizeof(faddr));
		  tmsg->from->name=xstrcpy(freename);
		  if (tmsg->from->name && (strlen(tmsg->from->name) > MAXNAME))
		       tmsg->from->name[MAXNAME]='\0';
		  tmsg->from->point=bestaka->point;
		  tmsg->from->node=bestaka->node;
		  tmsg->from->net=bestaka->net;
		  tmsg->from->zone=bestaka->zone;
		  tmsg->from->domain=xstrcpy(bestaka->domain);
	     }
	     free(from);
	p=hdr("Subject",msg);
	if (p)
	{
	     while (isspace(*p)) p++;
#ifdef DECODE_HEADERS
	     debug(3,"SUBJ was: \"%s\"", p);
	     convert_header_7bit_to_8bit(p);
#endif	     
	     tmsg->subj=xstrcpy(p);
	     if (*(p=tmsg->subj+strlen(tmsg->subj)-1) == '\n') *p='\0';
	     if (strlen(tmsg->subj) > MAXSUBJ) tmsg->subj[MAXSUBJ]='\0';
	}
	else tmsg->subj=xstrcpy(" ");
	
	debug(3,"SUBJ: \"%s\"",tmsg->subj);

	if ((p=hdr("X-FTN-FLAGS",msg))) tmsg->flags |= flagset(p);
	if (hdr("Return-Receipt-To",msg)) tmsg->flags |= FLG_RRQ;
	if (!newsmode)
	{
	     tmsg->flags |= FLG_PVT;
	     tmsg->flags |= FLG_K_S;
	}
	
	if ((p=hdr("Date",msg))) tmsg->date=parsedate(p,NULL);
	else tmsg->date=time((time_t *)NULL);
	
	if ((p=hdr("X-FTN-MSGID",msg)))
	{
	     tmsg->ftnorigin&=1;
	     while (isspace(*p)) p++;
	     tmsg->msgid_s=xstrcpy(p);
	     if (*(p=tmsg->msgid_s+strlen(tmsg->msgid_s)-1) == '\n') *p='\0';
	}
	else if ((p=hdr("Message-ID",msg)))
	{
	     tmsg->ftnorigin &=
		  ftnmsgid(p,&(tmsg->msgid_a),&(tmsg->msgid_n));
	}
	else
	{
	     tmsg->msgid_a=NULL;
	}
	
	if ((p=hdr("X-FTN-REPLY",msg)))
	{
	     while (isspace(*p)) p++;
	     tmsg->reply_s=xstrcpy(p);
	     if (*(p=tmsg->reply_s+strlen(tmsg->reply_s)-1) == '\n') *p='\0';
	}
	else if ((p=hdr("In-Reply-To",msg)) == NULL)
	{
	     p=hdr("References",msg);
	     if (p)
	     {
		  for (r=p+strlen(p); (*r != ' ') && (r >= p); r--);
		  p=r;
	     }
	}
	if (p)
	{
	     (void)ftnmsgid(p,&(tmsg->reply_a),&(tmsg->reply_n));
	}
	else
	{
	     tmsg->reply_a=NULL;
	}
	
	debug(3,"DATE: %s, MSGID: %s %lu, REPLY: %s %lu",
	      ftndate(tmsg->date),
	      S(tmsg->msgid_a),tmsg->msgid_n,
	      S(tmsg->reply_a),tmsg->reply_n);

	if ((p=hdr("Organization",msg)))
	{
	     while (isspace(*p)) p++;
	     tmsg->origin=xstrcpy(p);
	     if (*(p=tmsg->origin+strlen(tmsg->origin)-1) == '\n') *p='\0';
	}

	debug(3,"ORIGIN: %s",S(tmsg->origin));

	return tmsg;
}
