#include <stdlib.h>
#include <stdio.h>
#include <limits.h>
#include <string.h>
#include <ctype.h>
#include <time.h>

#ifndef ULONG_MAX
#define ULONG_MAX 4294967295
#endif

void convert_header_7bit_to_8bit(char *s)
{
#define DECODE_HEX(x) (isdigit(x)!=0?((x)-48):(((x)&0xDF)-55))

/* static const char BASE64_ALPHABET[]="ABCDEFGHIJKLMNOPQRSTUVWXYZ"
   "abcdefghijklmnopqrstuvwxyz"
   "0123456789+/"; */

    static const char UNBASE64_ALPHABET[]={"\x3E\xFF\xFF\xFF\x3F"
					   "\x34\x35\x36\x37\x38"
					   "\x39\x3A\x3B\x3C\x3D"
					   "\xFF\xFF\xFF\x00\xFF\xFF\xFF"
					   "\x00\x01\x02\x03\x04"
					   "\x05\x06\x07\x08\x09"
					   "\x0A\x0B\x0C\x0D\x0E"
					   "\x0F\x10\x11\x12\x13"
					   "\x14\x15\x16\x17\x18\x19"
					   "\xFF\xFF\xFF\xFF\xFF\xFF"
					   "\x1A\x1B\x1C\x1D\x1E"
					   "\x1F\x20\x21\x22\x23"
					   "\x24\x25\x26\x27\x28"
					   "\x29\x2A\x2B\x2C\x2D"
					   "\x2E\x2F\x30\x31\x32\x33"};
    char *p=s, *p1;
    char ts[10];
    int i,j;

    while ( s[0]!=0 ) {
	if ( s[0]=='=' && s[1]=='?' && strlen(s)>=14 ) {
	    strncpy(ts, s, 9); ts[9]=0; i=0;
	    while ( ts[i]!=0 ) {if ( ts[i]>64 && ts[i]<91 ) ts[i]|=0x20; i++;}

	    if ( strcmp(ts, "=?koi8-r?")==0 ) {
		ts[0]=s[9]; s+=11;

		if ( (ts[0]|0x20)=='q' ) {
		    /* decode quote-printable */

		    while ( (*s)!=0 && (*s)!='?' ) {
			if ( ((*s)=='=' && s[1]!=0)
			     &&
			     (isxdigit(s[1])!=0 && isxdigit(s[2])!=0) ) {
			    (*p)=(DECODE_HEX(s[1])<<4)+DECODE_HEX(s[2]);
			    s+=2;
			}
			else
			    if ( (*s)=='_' ) (*p)=' ';
			    else
				(*p)=(*s);

			p++; s++;
		    }
		}
		else
		    if ( (ts[0]|0x20)=='b' )
			{
			    /* decode base64 */

			    union
			    {
				char items[4];
				long all;
			    } base64_packet;
			    char unbase64_data[3];

			    i=j=0; base64_packet.all=0;
			    while ( (*s)!=0 && (*s)!='?' ) {
				if ( (*s)>43 && (*s)<123 && UNBASE64_ALPHABET[(*s)-43]!=((char)-1) ) {
				    base64_packet.items[i]=UNBASE64_ALPHABET[(*s)-43];

				    if ( (*s)=='=' ) j++;

				    if ( i==3 ) {
					unbase64_data[0]=(base64_packet.items[0]<<2)|
					    (base64_packet.items[1]>>4);
					unbase64_data[1]=(base64_packet.items[1]<<4)|
					    (base64_packet.items[2]>>2);
					unbase64_data[2]=(base64_packet.items[2]<<6)|
					    (base64_packet.items[3]);

					j=3-j;
					for (i=0;i<j;i++) {(*p)=unbase64_data[i]; p++;}

					i=j=0; base64_packet.all=0;
				    }
				    else
					i++;
				}
				else
				    {
					(*p)=(*s);
					p++;
				    }

				s++;
			    }
			}

		if ( s[0]=='?' && s[1]=='=' ) {
		    s+=2;
		}
	    }
	    else
		{/*  =?koi8r? -   */
		    *p=*s; s++; p++;
		}
	}
	else
	    {
		if ( s[0]=='\n' && (s[1]=='\t' || s[1]==' ')) /*     */
		    {
			s+=2;
		    }
		    else
		       {
			*p=*s; s++; p++;
		    }
	    }
    }
    *p=0;
}

main (int argc, char *argv[])
{
  char str[1024];

  strcpy (str, "=?KOI8-R?Q?=DC=D4=CF_=D3=C1=C2=D6=2C_=D3=C4=C5=CC=C1=CE=CE=D9?=\n =?KOI8-R?Q?=CA_=CD=CF=DA=C9=CC=CC=CF=CA=3F_=D0=CF=D3=CC=C5_=DA=CE=C1?=\n =?KOI8-R?Q?=CB=C1_=D0=D2=CF=C2=C5=CC=3A_=DA=C4=C5=D3=D8_=D4=CF=D6=C5?=");
  convert_header_7bit_to_8bit(str);
  puts(str);

  strcpy (str, "Re: =?KOI8-R?Q?=DC=D4=CF_=D3=C1=C2=D6=2C_=D3=C4=C5=CC=C1=CE=CE?=\n =?KOI8-R?Q?=D9=CA_=CD=CF=DA=C9=CC=CC=CF=CA=3F_=D0=CF=D3=CC=C5_=DA=CE?=\n =?KOI8-R?Q?=C1=CB=C1_=D0=D2=CF=C2=C5=CC=3A_=DA=C4=C5=D3=D8_=D4=CF=D6?=\n =?KOI8-R?Q?=C5?=");
  convert_header_7bit_to_8bit(str);
  puts(str);

  strcpy (str, "Re:\n =?koi8-r?Q?=DC=D4=CF_=D3=C1=C2=D6,_=D3=C4=C5=CC=C1=CE=CE=D9=CA_=CD=CF=DA?=\n =?koi8-r?Q?=C9=CC=CC=CF=CA=3F_=D0=CF=D3=CC=C5_=DA=CE=C1=CB=C1_=D0=D2=CF?=\n =?koi8-r?Q?=C2=C5=CC:_=DA=C4=C5=D3=D8_=D4=CF=D6=C5?=");
  convert_header_7bit_to_8bit(str);
  puts(str);

exit(0);

  strcpy (str, "=?KOI8-R?Q?=D0=CF=C4=CB=CC=C0=DE=C5=CE=C9=C5_=CB_=D0=CF=D2=D4=C1?=\n\t=?KOI8-R?Q?=CC=D5?=");
  convert_header_7bit_to_8bit(str);
  puts(str);

  strcpy (str, "=?koi8-r?Q?=C5=DD=C5_=CF=C4=C9=CE_=C4=CC=C9=CE=CE=D9=CA_=D3=C1?=\n =?koi8-r?Q?=C2=D6_=CF=DE=C5=CE=D8_=C4=CC=C9=CE=CE=D9=CA_=D4=C1=CB=CF=CA?=\n =?koi8-r?Q?_=C4=CC=C9=CE=CE=D9=CA_=DE=D4=CF_=CF=DE=C5=CE=D8?=");
  convert_header_7bit_to_8bit(str);
  puts(str);

  exit (0);

  while (!feof(stdin)) {
    gets (str);
    convert_header_7bit_to_8bit(str);
    puts(str);
  }
}


