 /**********************************************************
 * File: xqcc.cpp
 * Created at Tue Jun 25 12:24:32 2002 by pryamognev // sernic@inbox.ru
 * qico control center for X
 * $Id: xqcc.cpp,v 0.2 2002/06/30 19:30:31 pryamognev Exp $
 **********************************************************/

#include "xqcc.h"

char *m_header=NULL, *m_status=NULL;
char qflgs[]=Q_CHARS;

void sigwinch(int s);
char *nothing="";

slot_t *slot;
qslot_t *queue;
int q_pos, q_first, q_max, sizechanged=0;

int qipc_msg_,count=0,vcount=0,qipc_msg1;
key_t qipc_key_,qipc_key1;

int len, rc, type, pid;
char buf[MSG_BUFFER], *data_, *p;
int lastfirst=1, lastpos=1;
char *towlog;
int wlogflg=0;

/*******************************************************************************/
FXDEFMAP(PollDialog) PollDialogMap[]={
  FXMAPFUNC(SEL_KEYRELEASE,PollDialog::ID_ADDRESS_ENTER,PollDialog::onCmdAddrEnter),
  FXMAPFUNC(SEL_COMMAND,PollDialog::ID_FILES_ENTER,PollDialog::onCmdFilesEntered),
  FXMAPFUNC(SEL_COMMAND,PollDialog::ID_DO_POLL,PollDialog::onCmdDoPoll),
  FXMAPFUNC(SEL_COMMAND,PollDialog::ID_FILE_BROWSE,PollDialog::onCmdFileBrowse),
};

FXIMPLEMENT(PollDialog,FXDialogBox,PollDialogMap,ARRAYNUMBER(PollDialogMap))

PollDialog::PollDialog(QicoWindow* owner):
  FXDialogBox(owner,"Poll node",DECOR_TITLE|DECOR_MINIMIZE|DECOR_MENU|DECOR_BORDER,0,0,400,330){
  
  // Bottom buttons
  poll_toolbarcontainer=new FXHorizontalFrame(this,FRAME_NONE|LAYOUT_SIDE_BOTTOM|LAYOUT_CENTER_X);
  poll_mainframe=new FXHorizontalFrame(this,FRAME_NONE|LAYOUT_FILL_X|LAYOUT_FILL_Y|LAYOUT_SIDE_TOP);

  poll_pollgroup=new FXGroupBox(poll_mainframe,"Poll",FRAME_RIDGE|LAYOUT_FILL_Y|LAYOUT_SIDE_LEFT);  

  poll_addresslabel=new FXLabel(poll_pollgroup,"Address:");
  poll_addressfield=new FXTextField(poll_pollgroup,1,this,ID_ADDRESS_ENTER,FRAME_RIDGE|LAYOUT_FIX_WIDTH,0,0,100);

  poll_fileslabel=new FXLabel(poll_pollgroup,"Files:");
  poll_filesfield=new FXTextField(poll_pollgroup,1,this,ID_FILES_ENTER,FRAME_RIDGE|LAYOUT_FIX_WIDTH,0,0,100);
  FXIcon *folder_openicon=new FXGIFIcon(getApp(),minifolderopen);
  poll_browse_button=new FXButton(poll_pollgroup,"",folder_openicon,this,ID_FILE_BROWSE,FRAME_RIDGE|BUTTON_TOOLBAR|LAYOUT_FIX_WIDTH|LAYOUT_FIX_HEIGHT,0,0,25,25);

  poll_hold_flavour=new FXRadioButton(poll_pollgroup,"Hold");
  poll_normal_flavour=new FXRadioButton(poll_pollgroup,"Normal");
  poll_direct_flavour=new FXRadioButton(poll_pollgroup,"Direct");
  poll_crash_flavour=new FXRadioButton(poll_pollgroup,"Crash");
  poll_imm_flavour=new FXRadioButton(poll_pollgroup,"Immediate");
  // Accept
  poll_nodelistgroup=new FXGroupBox(poll_mainframe,"Nodelist info",FRAME_RIDGE|LAYOUT_FILL_Y|LAYOUT_SIDE_RIGHT|LAYOUT_FILL_X);
  poll_nodelistlabel=new FXLabel(poll_nodelistgroup,"",0,JUSTIFY_LEFT);

  poll_toolbar=new FXToolBar(poll_toolbarcontainer,FRAME_RIDGE|LAYOUT_SIDE_BOTTOM|LAYOUT_CENTER_X);
  poll_accept_button=new FXButton(poll_toolbar,"&Accept",NULL,this,ID_DO_POLL,BUTTON_TOOLBAR|BUTTON_DEFAULT|BUTTON_INITIAL|ICON_ABOVE_TEXT|FRAME_RIDGE|LAYOUT_CENTER_X|LAYOUT_FIX_WIDTH|LAYOUT_FIX_HEIGHT,0,0,50,25);
  
  // Cancel
  poll_cancel_button=new FXButton(poll_toolbar,"&Cancel",NULL,this,FXDialogBox::ID_CANCEL,ICON_ABOVE_TEXT|FRAME_RIDGE|BUTTON_TOOLBAR|LAYOUT_CENTER_X|LAYOUT_FIX_WIDTH|LAYOUT_FIX_HEIGHT,0,0,50,25);



  font=new FXFont(getApp(),"fixed",10);
  text_color=FXRGB(150,230,150);
  back_color=FXRGB(90,90,90);
  hilite_color=FXRGB(0,0,0);
  
  poll_hold_flavour->setBackColor(back_color);
  poll_hold_flavour->setHiliteColor(hilite_color);
  poll_hold_flavour->setTextColor(text_color);
  poll_normal_flavour->setBackColor(back_color);
  poll_normal_flavour->setHiliteColor(hilite_color);
  poll_normal_flavour->setTextColor(text_color);
  poll_direct_flavour->setBackColor(back_color);
  poll_direct_flavour->setHiliteColor(hilite_color);
  poll_direct_flavour->setTextColor(text_color);
  poll_crash_flavour->setBackColor(back_color);
  poll_crash_flavour->setHiliteColor(hilite_color);
  poll_crash_flavour->setTextColor(text_color);
  poll_imm_flavour->setBackColor(back_color);
  poll_imm_flavour->setHiliteColor(hilite_color);
  poll_imm_flavour->setTextColor(text_color);

  poll_browse_button->setHiliteColor(hilite_color);
  poll_browse_button->setBackColor(back_color);

  back_color=FXRGB(127,127,127);
  poll_toolbar->setBackColor(back_color);
  poll_toolbar->setHiliteColor(hilite_color);
  poll_accept_button->setHiliteColor(hilite_color);
  poll_accept_button->setBackColor(back_color);
  poll_cancel_button->setHiliteColor(hilite_color);
  poll_cancel_button->setBackColor(back_color);
  back_color=FXRGB(90,90,90);

  poll_toolbarcontainer->setBackColor(back_color);
  poll_addressfield->setHiliteColor(hilite_color);
  poll_filesfield->setHiliteColor(hilite_color);
  poll_mainframe->setBackColor(back_color);
  //  poll_filesframe->setBackColor(back_color);
  poll_pollgroup->setBackColor(back_color);
  poll_pollgroup->setTextColor(FXRGB(255,255,0));
  poll_pollgroup->setHiliteColor(hilite_color);
  poll_nodelistgroup->setBackColor(back_color);
  poll_nodelistgroup->setTextColor(FXRGB(255,255,0));
  poll_nodelistgroup->setHiliteColor(hilite_color);

  text_color=FXRGB(100,170,170);

  poll_addresslabel->setBackColor(back_color);
  poll_addresslabel->setTextColor(text_color);
  poll_fileslabel->setBackColor(back_color);
  poll_fileslabel->setTextColor(text_color);
  poll_nodelistlabel->setBackColor(back_color);
  poll_nodelistlabel->setTextColor(FXRGB(165,165,165));
  poll_nodelistlabel->setFont(font);

  back_color=FXRGB(120,120,120);
  poll_addressfield->setBackColor(back_color);
  poll_filesfield->setBackColor(back_color);
  
}

PollDialog::~PollDialog(){
  }

// Map
FXDEFMAP(QicoWindow) QicoWindowMap[]={
  FXMAPFUNC(SEL_TIMEOUT,QicoWindow::ID_TIMER,QicoWindow::onCmdTimer),
  FXMAPFUNC(SEL_COMMAND,QicoWindow::ID_QUIT,QicoWindow::onCmdQuit),
  FXMAPFUNC(SEL_KEYRELEASE,QicoWindow::ID_QUIT,QicoWindow::onCmdQuit),
  FXMAPFUNC(SEL_COMMAND,QicoWindow::ID_REREAD,QicoWindow::onCmdReread),
  FXMAPFUNC(SEL_COMMAND,QicoWindow::ID_RESCAN,QicoWindow::onCmdRescan),
  FXMAPFUNC(SEL_COMMAND,QicoWindow::ID_POLL,QicoWindow::onCmdPoll),
  //  FXMAPFUNC(SEL_KEYRELEASE,QicoWindow::ID_POLL,QicoWindow::onCmdPoll),
  FXMAPFUNC(SEL_COMMAND,QicoWindow::ID_SEND,QicoWindow::onCmdSend),
  //  FXMAPFUNC(SEL_KEYRELEASE,QicoWindow::ID_SEND,QicoWindow::onCmdSend),
  FXMAPFUNC(SEL_COMMAND,QicoWindow::ID_FREQ,QicoWindow::onCmdFreq),
  //  FXMAPFUNC(SEL_KEYRELEASE,QicoWindow::ID_FREQ,QicoWindow::onCmdFreq),
  FXMAPFUNC(SEL_COMMAND,QicoWindow::ID_NODELIST,QicoWindow::onCmdNodelist),
  //  FXMAPFUNC(SEL_KEYRELEASE,QicoWindow::ID_NODELIST,QicoWindow::onCmdNodelist),
  FXMAPFUNC(SEL_COMMAND,QicoWindow::ID_MAIN,QicoWindow::onCmdMain),
  FXMAPFUNC(SEL_KEYRELEASE,QicoWindow::ID_MAIN,QicoWindow::onCmdMain),
  FXMAPFUNC(SEL_COMMAND,QicoWindow::ID_SESS,QicoWindow::onCmdSess),
  FXMAPFUNC(SEL_KEYRELEASE,QicoWindow::ID_SESS,QicoWindow::onCmdSess),
  FXMAPFUNC(SEL_COMMAND,QicoWindow::ID_OUTBOUND,QicoWindow::onCmdOutbound),
  FXMAPFUNC(SEL_KEYRELEASE,QicoWindow::ID_OUTBOUND,QicoWindow::onCmdOutbound),
  FXMAPFUNC(SEL_KEYRELEASE,QicoWindow::ID_OUTBOUND_BOX,QicoWindow::onCmdOutboundKeyPress),
  FXMAPFUNC(SEL_COMMAND,QicoWindow::ID_SKIP,QicoWindow::onCmdSkip),
};

FXIMPLEMENT(QicoWindow,FXMainWindow,QicoWindowMap,ARRAYNUMBER(QicoWindowMap))
  
  QicoWindow::QicoWindow(FXApp* a):FXMainWindow(a,"qico control center for X",NULL,NULL,DECOR_TITLE|DECOR_MINIMIZE|DECOR_MAXIMIZE|DECOR_STRETCHABLE|DECOR_MENU|DECOR_RESIZE,0,0,800,600){
  skipicon=new FXGIFIcon(getApp(),skipico);
  exiticon=new FXGIFIcon(getApp(),exitico);
  rereadicon=new FXGIFIcon(getApp(),rereadico);
  rescanicon=new FXGIFIcon(getApp(),rescanico);
  pollicon=new FXGIFIcon(getApp(),pollico);
  sendicon=new FXGIFIcon(getApp(),sendico);
  freqicon=new FXGIFIcon(getApp(),freqico);
  nodelisticon=new FXGIFIcon(getApp(),nodelistico);
  connectingicon=new FXGIFIcon(getApp(),connectingico);

  setIcon(connectingicon);
  setMiniIcon(connectingicon);
  
  new FXToolTip(getApp());

  // Toolbar

  toolbarcontainer=new FXHorizontalFrame(this,LAYOUT_SIDE_TOP|LAYOUT_FILL_X);
  toolbartab=new FXToolBarTab(toolbarcontainer,NULL,FRAME_RAISED);
  toolbar=new FXToolBar(toolbarcontainer,FRAME_RIDGE|PACK_UNIFORM_WIDTH|LAYOUT_SIDE_TOP|LAYOUT_FILL_X);

  // Buttons
  skipbutton=new FXButton(toolbar,"S&kip file",skipicon,this,ID_SKIP,ICON_ABOVE_TEXT|FRAME_RIDGE|BUTTON_TOOLBAR|LAYOUT_FIX_WIDTH|LAYOUT_FIX_HEIGHT,0,0,60,45);

  rereadbutton=new FXButton(toolbar,"Reread cfg",rereadicon,this,ID_REREAD, ICON_ABOVE_TEXT|FRAME_RIDGE|BUTTON_TOOLBAR|LAYOUT_FIX_WIDTH|LAYOUT_FIX_HEIGHT,0,0,75,45);

  rescanbutton=new FXButton(toolbar,"&Rescan",rescanicon,this,ID_RESCAN, ICON_ABOVE_TEXT|FRAME_RIDGE|BUTTON_TOOLBAR|LAYOUT_FIX_WIDTH|LAYOUT_FIX_HEIGHT,0,0,55,45);
  nodelistbutton=new FXButton(toolbar,"Nodelist &info",nodelisticon,this,ID_NODELIST, ICON_ABOVE_TEXT|FRAME_RIDGE|BUTTON_TOOLBAR|LAYOUT_FIX_WIDTH|LAYOUT_FIX_HEIGHT,0,0,85,45);

  pollbutton=new FXButton(toolbar,"&Poll",pollicon,this,ID_POLL, ICON_ABOVE_TEXT|FRAME_RIDGE|BUTTON_TOOLBAR|LAYOUT_FIX_WIDTH|LAYOUT_FIX_HEIGHT,0,0,50,45);

  sendbutton=new FXButton(toolbar,"&Send",sendicon,this,ID_SEND, ICON_ABOVE_TEXT|FRAME_RIDGE|BUTTON_TOOLBAR|LAYOUT_FIX_WIDTH|LAYOUT_FIX_HEIGHT,0,0,50,45);

  freqbutton=new FXButton(toolbar,"F&Req",freqicon,this,ID_FREQ, ICON_ABOVE_TEXT|FRAME_RIDGE|BUTTON_TOOLBAR|LAYOUT_FIX_WIDTH|LAYOUT_FIX_HEIGHT,0,0,50,45);


  exitbutton=new FXButton(toolbar,"&Quit",exiticon,this,ID_QUIT,    ICON_ABOVE_TEXT|FRAME_RIDGE|BUTTON_TOOLBAR|LAYOUT_FIX_WIDTH|LAYOUT_FIX_HEIGHT,0,0,50,45);

  // Status bar
  statusbarframe=new FXHorizontalFrame(this,LAYOUT_SIDE_BOTTOM|LAYOUT_FILL_X);
  statusbar=new FXStatusLine(statusbarframe,0,LAYOUT_SIDE_BOTTOM|FRAME_NONE|LAYOUT_FILL_X);
  statusbar_=new FXStatusLine(statusbarframe,0,LAYOUT_SIDE_BOTTOM|FRAME_NONE|LAYOUT_FILL_X);
  statusbar->setFrameStyle(FRAME_RIDGE); statusbar_->setFrameStyle(FRAME_RIDGE);
  // TabBook
  contents=new FXVerticalFrame(this,LAYOUT_SIDE_TOP|FRAME_NONE|LAYOUT_FILL_X|LAYOUT_FILL_Y);
  buttons=new FXHorizontalFrame(contents,LAYOUT_SIDE_TOP|FRAME_RIDGE|LAYOUT_FILL_X);
  switcher=new FXSwitcher(contents,LAYOUT_FILL_Y|LAYOUT_FILL_X|LAYOUT_LEFT|FRAME_NONE);

  // Main log tab

  switchbutton1=new FXButton(buttons,"&1 Log window      ",NULL,this,ID_MAIN,ICON_ABOVE_TEXT|FRAME_RIDGE);
  switchbutton2=new FXButton(buttons,"&2 Session         ",NULL,this,ID_SESS,ICON_ABOVE_TEXT|FRAME_RIDGE);
  switchbutton3=new FXButton(buttons,"&3 Outbound manager",NULL,this,ID_OUTBOUND,ICON_ABOVE_TEXT|FRAME_RIDGE);
  splitter=new FXSplitter(switcher,LAYOUT_FILL_Y|LAYOUT_FILL_X|LAYOUT_BOTTOM|SPLITTER_TRACKING|SPLITTER_VERTICAL|SPLITTER_REVERSED);

  // Mainlog
  maingroup=new FXGroupBox(splitter,"Main log: ",GROUPBOX_TITLE_CENTER|FRAME_RIDGE|LAYOUT_FILL_X|LAYOUT_FILL_Y);
  mainlog=new FXText(maingroup,this,ID_MAIN_LOG,SCROLLERS_TRACK|LAYOUT_FILL_X|LAYOUT_FILL_Y|TEXT_READONLY);
  mastergroup=new FXGroupBox(splitter,"Master log: ",GROUPBOX_TITLE_CENTER|FRAME_RIDGE|LAYOUT_FILL_X|LAYOUT_FILL_Y);
  masterlog=new FXText(mastergroup,this,ID_MASTER_LOG,SCROLLERS_TRACK|LAYOUT_FILL_X|LAYOUT_FILL_Y|TEXT_READONLY);

  // Session tab

  splitter_session=new FXSplitter(switcher,LAYOUT_FILL_Y|LAYOUT_FILL_X|LAYOUT_CENTER_Y|LAYOUT_FIX_Y|SPLITTER_TRACKING);

  // Transmitting
  transmitframe=new FXVerticalFrame(splitter_session,FRAME_NONE|LAYOUT_FILL_X|LAYOUT_FILL_Y);
  
  // Receiving
  recvgroup=new FXGroupBox(transmitframe,"Receiving: ",GROUPBOX_TITLE_LEFT|FRAME_RIDGE|LAYOUT_FILL_X|LAYOUT_FILL_Y|LAYOUT_SIDE_TOP);
  recvfile_label=new FXLabel(recvgroup,"\n\n\n",0,LAYOUT_SIDE_TOP|JUSTIFY_LEFT);
  recvbar=new FXProgressBar(recvgroup,NULL,0,LAYOUT_FILL_X|FRAME_LINE|PROGRESSBAR_PERCENTAGE,0,0,0,0);
  recvfile_total_label=new FXLabel(recvgroup,"\n",0,LAYOUT_SIDE_TOP|JUSTIFY_LEFT);
  recv_t_bar=new FXProgressBar(recvgroup,NULL,0,LAYOUT_FILL_X|FRAME_LINE|PROGRESSBAR_PERCENTAGE,0,0,0,0);

  // Sending
  sendgroup=new FXGroupBox(transmitframe,"Sending: ",GROUPBOX_TITLE_LEFT|FRAME_RIDGE|LAYOUT_FILL_X|LAYOUT_FILL_Y|LAYOUT_SIDE_BOTTOM);
  sendfile_label=new FXLabel(sendgroup,"                                                                                              \n\n\n",0,LAYOUT_SIDE_TOP|JUSTIFY_LEFT);
  sendbar=new FXProgressBar(sendgroup,NULL,0,LAYOUT_FILL_X|FRAME_LINE|PROGRESSBAR_PERCENTAGE,0,0,0,0);
  sendfile_total_label=new FXLabel(sendgroup,"\n",0,LAYOUT_SIDE_TOP|JUSTIFY_LEFT);
  send_t_bar=new FXProgressBar(sendgroup,NULL,0,LAYOUT_FILL_X|FRAME_LINE|PROGRESSBAR_PERCENTAGE,0,0,0,0);


  // Queue
  queuegroup=new FXGroupBox(switcher,"Queue: ",GROUPBOX_TITLE_CENTER|FRAME_RIDGE|LAYOUT_FILL_X|LAYOUT_FILL_Y);

  queue_label=new FXLabel(queuegroup,"* Address          Mail  Files  Try Flags",0,LAYOUT_SIDE_TOP|JUSTIFY_LEFT);
 
  queuebox=new FXList(queuegroup,7,this,ID_OUTBOUND_BOX,VSCROLLER_NEVER|LAYOUT_FILL_X|LAYOUT_FILL_Y|LAYOUT_SIDE_BOTTOM|LIST_BROWSESELECT);
  
  // Font  
  font=new FXFont(getApp(),"fixed",10);

  // EMSI
  infogroup=new FXGroupBox(splitter_session,"Information: ",GROUPBOX_TITLE_LEFT|FRAME_RIDGE|LAYOUT_FILL_X);
  emsi_station_label=new FXLabel(infogroup,"Station:",0,LAYOUT_SIDE_TOP|JUSTIFY_LEFT);
  emsi_location_label=new FXLabel(infogroup,"Location:",0,LAYOUT_SIDE_TOP|JUSTIFY_LEFT);
  emsi_sysop_label=new FXLabel(infogroup,"Sysop:",0,LAYOUT_SIDE_TOP|JUSTIFY_LEFT);
  emsi_flags_label=new FXLabel(infogroup,"Flags:",0,LAYOUT_SIDE_TOP|JUSTIFY_LEFT);
  emsi_phone_label=new FXLabel(infogroup,"Phone:",0,LAYOUT_SIDE_TOP|JUSTIFY_LEFT);
  emsi_aka_label=new FXLabel(infogroup,"AKA:",0,LAYOUT_SIDE_TOP|JUSTIFY_LEFT);
  emsi_pwd_label=new FXLabel(infogroup,nothing,0,LAYOUT_SIDE_TOP|JUSTIFY_LEFT);
  emsi_lst_label=new FXLabel(infogroup,nothing,0,LAYOUT_SIDE_TOP|JUSTIFY_LEFT);

  polldialog=new PollDialog(this);
}

char *sscat(char *s, int size){
  if(size<1024) {
    sprintf(s+strlen(s), " %4d", size);
    return s;
  }
  if(size<1024*1024) {
    sprintf(s+strlen(s), "%4dK", size/1024);
    return s;
  }
  sprintf(s+strlen(s), "%4dM", size/(1024*1024));
  return s;
}

void QicoWindow::create(){

  FXMainWindow::create();
  getApp()->addTimeout(1,this,ID_TIMER);

  mainlog->setStyled();
  masterlog->setStyled();
  hilitestyles=(FXHiliteStyle*)malloc(sizeof(FXHiliteStyle)*10);

  hilitestyles[0].normalForeColor=FXRGB(230,230,150);
  hilitestyles[0].normalBackColor=FXRGB(90,90,90);
  hilitestyles[0].selectBackColor=FXRGB(120,120,120);
  hilitestyles[0].style=0;

  hilitestyles[1].normalForeColor=FXRGB(230,150,230);
  hilitestyles[1].normalBackColor=FXRGB(90,90,90);
  hilitestyles[1].selectBackColor=FXRGB(120,120,120);
  hilitestyles[1].style=0;

  hilitestyles[2].normalForeColor=FXRGB(230,230,230);
  hilitestyles[2].normalBackColor=FXRGB(90,90,90);
  hilitestyles[2].selectBackColor=FXRGB(120,120,120);
  hilitestyles[2].style=0;

  hilitestyles[3].normalForeColor=FXRGB(100,170,170);
  hilitestyles[3].normalBackColor=FXRGB(90,90,90);
  hilitestyles[3].selectBackColor=FXRGB(120,120,120);
  hilitestyles[3].style=0;

  hilitestyles[4].normalForeColor=FXRGB(150,230,230);
  hilitestyles[4].normalBackColor=FXRGB(90,90,90);
  hilitestyles[4].selectBackColor=FXRGB(120,120,120);
  hilitestyles[4].style=0;

  hilitestyles[5].normalForeColor=FXRGB(150,230,150);
  hilitestyles[5].normalBackColor=FXRGB(90,90,90);
  hilitestyles[5].selectBackColor=FXRGB(120,120,120);
  hilitestyles[5].style=0;

  hilitestyles[6].normalForeColor=FXRGB(230,150,150);
  hilitestyles[6].normalBackColor=FXRGB(90,90,90);
  hilitestyles[6].selectBackColor=FXRGB(120,120,120);
  hilitestyles[6].style=0;

  masterlog->setHiliteStyles(hilitestyles);
  masterlog->setSelBackColor(FXRGB(120,120,120));
  
  mainlog->setHiliteStyles(hilitestyles);
  mainlog->setSelBackColor(FXRGB(120,120,120));
  
  font->create();
  hilite_color=FXRGB(0,0,0);
  text_color=FXRGB(0,0,0);
  back_color=FXRGB(70,120,160);

  sendbar->setBarColor(back_color);
  sendbar->setTextColor(text_color);
  sendbar->setBorderColor(text_color);
  recvbar->setBarColor(back_color);
  recvbar->setTextColor(text_color);
  recvbar->setBorderColor(text_color);

  back_color=FXRGB(0,130,130);
  send_t_bar->setBarColor(back_color);
  send_t_bar->setTextColor(text_color);
  send_t_bar->setBorderColor(text_color);
  recv_t_bar->setBarColor(back_color);
  recv_t_bar->setTextColor(text_color);
  recv_t_bar->setBorderColor(text_color);

  back_color=FXRGB(80,80,80);
  sendbar->setBarBGColor(back_color);
  send_t_bar->setBarBGColor(back_color);
  recvbar->setBarBGColor(back_color);
  recv_t_bar->setBarBGColor(back_color);

  back_color=FXRGB(90,90,90);
  text_color=FXRGB(100,210,220);
  mainlog->verticalScrollBar()->setHiliteColor(FXRGB(127,127,127));
  mainlog->verticalScrollBar()->setBackColor(back_color);
  masterlog->verticalScrollBar()->setHiliteColor(FXRGB(127,127,127));
  masterlog->verticalScrollBar()->setBackColor(back_color);
  switchbutton1->setHiliteColor(FXRGB(70,70,70));
  switchbutton1->setBackColor(back_color);
  switchbutton1->setTextColor(text_color);
  switchbutton1->setFont(font);
  switchbutton2->setBackColor(back_color);
  switchbutton2->setTextColor(text_color);
  switchbutton2->setHiliteColor(FXRGB(70,70,70));
  switchbutton2->setFont(font);
  switchbutton3->setBackColor(back_color);
  switchbutton3->setTextColor(text_color);
  switchbutton3->setHiliteColor(FXRGB(70,70,70));
  switchbutton3->setFont(font);
  buttons->setBackColor(back_color);
  buttons->setHiliteColor(hilite_color);
  text_color=FXRGB(255,255,0);

  queue_label->setBackColor(back_color);
  queue_label->setTextColor(text_color);
  queue_label->setFont(font);

  infogroup->setBackColor(back_color);
  infogroup->setTextColor(text_color);
  infogroup->setHiliteColor(hilite_color);
  infogroup->setFont(font);

  maingroup->setBackColor(back_color);
  maingroup->setTextColor(text_color);
  maingroup->setHiliteColor(hilite_color);
  maingroup->setFont(font);

  mastergroup->setBackColor(back_color);
  mastergroup->setTextColor(text_color);
  mastergroup->setHiliteColor(hilite_color);
  mastergroup->setFont(font);

  queuegroup->setBackColor(back_color);
  queuegroup->setTextColor(text_color);
  queuegroup->setHiliteColor(hilite_color);
  queuegroup->setFont(font);

  sendgroup->setBackColor(back_color);
  sendgroup->setTextColor(text_color);
  sendgroup->setHiliteColor(hilite_color);
  sendgroup->setFont(font);

  recvgroup->setBackColor(back_color);
  recvgroup->setTextColor(text_color);
  recvgroup->setHiliteColor(hilite_color);
  recvgroup->setFont(font);
  switcher->setBackColor(back_color);

  text_color=FXRGB(0,230,40);

  statusbar_->setBackColor(back_color);
  statusbar_->setTextColor(text_color);
  statusbar_->setHiliteColor(hilite_color);
  statusbar_->setFont(font);

  rescanbutton->setHiliteColor(hilite_color);
  nodelistbutton->setHiliteColor(hilite_color);
  pollbutton->setHiliteColor(hilite_color);
  sendbutton->setHiliteColor(hilite_color);
  freqbutton->setHiliteColor(hilite_color);
  exitbutton->setHiliteColor(hilite_color);
  rereadbutton->setHiliteColor(hilite_color);
  skipbutton->setHiliteColor(hilite_color);
  toolbar->setHiliteColor(hilite_color);
  toolbarcontainer->setHiliteColor(hilite_color);
  toolbarcontainer->setBackColor(back_color);
  back_color=FXRGB(127,127,127);
  toolbar->setBackColor(back_color);
  exitbutton->setBackColor(back_color);
  nodelistbutton->setBackColor(back_color);
  pollbutton->setBackColor(back_color);
  sendbutton->setBackColor(back_color);
  freqbutton->setBackColor(back_color);
  rereadbutton->setBackColor(back_color);
  rescanbutton->setBackColor(back_color);
  skipbutton->setBackColor(back_color);

  text_color=FXRGB(0,130,130);
  toolbartab->setHiliteColor(hilite_color);
  toolbartab->setBackColor(back_color);
  toolbartab->setActiveColor(text_color);

  back_color=FXRGB(90,90,90);
  text_color=FXRGB(0,255,255);


  text_color=FXRGB(100,210,220);
  
  statusbar->setBackColor(back_color);
  statusbar->setTextColor(text_color);
  statusbar->setHiliteColor(hilite_color);
  statusbar->setFont(font);

  text_color=FXRGB(190,190,0);

  statusbarframe->setBackColor(back_color);
  transmitframe->setBackColor(back_color);

  splitter->setBackColor(back_color);
  splitter_session->setBackColor(back_color);
  getApp()->setBackColor(back_color);
  contents->setBackColor(back_color);

  text_color=FXRGB(160,160,0);
  emsi_lst_label->setTextColor(text_color); emsi_lst_label->setBackColor(back_color);

  text_color=FXRGB(80,0,0);
  emsi_pwd_label->setTextColor(text_color); emsi_pwd_label->setBackColor(back_color);

  text_color=FXRGB(0,190,0);
  emsi_aka_label->setTextColor(text_color); emsi_aka_label->setBackColor(back_color);

  text_color=FXRGB(70,150,160);
  emsi_phone_label->setTextColor(text_color); emsi_phone_label->setBackColor(back_color);
  emsi_flags_label->setTextColor(text_color); emsi_flags_label->setBackColor(back_color);
  emsi_sysop_label->setTextColor(text_color); emsi_sysop_label->setBackColor(back_color);

  text_color=FXRGB(100,210,220);
  emsi_location_label->setTextColor(text_color); emsi_location_label->setBackColor(back_color);
  emsi_station_label->setTextColor(text_color); emsi_station_label->setBackColor(back_color);

  text_color=FXRGB(165,165,165);

  queuebox->setBackColor(back_color);
  queuebox->setTextColor(text_color);
  queuebox->setFont(font);
  queuebox->setSelBackColor(back_color);

  sendfile_label->setBackColor(back_color);
  sendfile_label->setTextColor(text_color);
  sendfile_label->setFont(font);

  sendfile_total_label->setBackColor(back_color);
  sendfile_total_label->setTextColor(text_color);
  sendfile_total_label->setFont(font);

  recvfile_label->setBackColor(back_color);
  recvfile_label->setTextColor(text_color);
  recvfile_label->setFont(font);

  recvfile_total_label->setBackColor(back_color);
  recvfile_total_label->setTextColor(text_color);
  recvfile_total_label->setFont(font);

  mainlog->setBackColor(back_color);
  mainlog->setTextColor(text_color);
  mainlog->setFont(font);

  mainlog->setCursorColor(text_color);

  masterlog->setBackColor(back_color);
  masterlog->setTextColor(text_color);
  masterlog->setFont(font);

  masterlog->setCursorColor(text_color);

  back_color=FXRGB(150,150,150);
  recvfile_total_label->setText("Total: 0b of 0b\n(0:00:00)");
  sendfile_total_label->setText("Total: 0b of 0b\n(0:00:00)");
  sendfile_label->setText("\nSending file 0 of 0\n\n*-none-* 0 / 0 bytes\n(0:00:00) 0 cps");
  recvfile_label->setText("\nReceiving file 0 of 0\n\n*-none-* 0 / 0 bytes\n(0:00:00) 0 cps");
  
  switchbutton1->setState(STATE_ENGAGED);

  FXuint size,n;
  FXchar *text;
  FILE *fp;
  if (!(fp=fopen(cfgs(CFG_LOG),"r"))) { mainlog->appendText("Error inserting your log-file: file not found...",48);}
  else{
    size=FXFile::size(cfgs(CFG_LOG));
    if(!FXCALLOC(&text,FXchar,size+1)){
      mainlog->appendText("Error inserting your log-file: file too big...",46);
      fclose(fp);
    }else{
      n=fread(text,1,size-1,fp);
      mainlog->appendText(text,n);
      mainlog->makePositionVisible(size-1);
      FXFREE(&text);
    }
  }
  stylizeall();
  if (!(fp=fopen(cfgs(CFG_MASTERLOG),"r"))) { masterlog->appendText("Error inserting your log-file: file not found...",48);}
  else{
    size=FXFile::size(cfgs(CFG_MASTERLOG));
    if(!FXCALLOC(&text,FXchar,size+1)){
      masterlog->appendText("Error inserting your log-file: file too big...",46);
      fclose(fp);
    }else{
      n=fread(text,1,size-1,fp);
      masterlog->appendText(text,n);
      masterlog->makePositionVisible(size-1);
      FXFREE(&text);
    }
  }
  stylizeall();
  masterlog->killFocus();
  mainlog->setFocus();
  show(PLACEMENT_SCREEN);
}

long QicoWindow::onCmdMain(FXObject*,FXSelector,void*){
  switcher->setCurrent(0);
  switchbutton1->setState(STATE_ENGAGED);
  switchbutton1->killFocus();
  queuebox->setFocus();
  switchbutton2->setState(STATE_UNCHECKED);
  switchbutton3->setState(STATE_UNCHECKED);
  mainlog->setFocus();
  return 0;
}

long QicoWindow::onCmdSess(FXObject*,FXSelector,void*){
  switcher->setCurrent(1);
  switchbutton2->setState(STATE_ENGAGED);
  switchbutton2->killFocus();
  switchbutton1->setState(STATE_UNCHECKED);
  switchbutton3->setState(STATE_UNCHECKED);
  return 0;
}

long QicoWindow::onCmdOutbound(FXObject*,FXSelector,void*){
  switcher->setCurrent(2);
  switchbutton3->setState(STATE_ENGAGED);
  switchbutton3->killFocus();
  switchbutton1->setState(STATE_UNCHECKED);
  switchbutton2->setState(STATE_UNCHECKED);
  queuebox->setFocus();
  return 0;
}

long QicoWindow::onCmdOutboundKeyPress(FXObject*,FXSelector,void* ptr){
  FXEvent *event=(FXEvent*)ptr;
  ftnaddr_t fa;
  FXString stmp;
  char tmp[255];
  sts_t sts;
  int rc=0;
  stmp=queuebox->getItemText(queuebox->getCurrentItem());
  sprintf(tmp,"%s",stmp.text());
  tmp[strlen(tmp)-strlen(strchr(tmp,' '))]='\0';
  parseftnaddr(tmp, &fa, &DEFADDR, 0);
  switch (event->code){
  case KEY_Cyrillic_er:
  case KEY_h:{
    if(bso_locknode(&fa)) {
      rc=bso_flavor('H');
    }
    rc=bso_poll(&fa,rc);
    bso_unlocknode(&fa);
    sendcommand(QR_SCAN);
    break;
  }
  case KEY_Cyrillic_te:
  case KEY_n:{
    if(bso_locknode(&fa)) {
      rc=bso_flavor('N');
    }
    rc=bso_poll(&fa,rc);
    bso_unlocknode(&fa);
    sendcommand(QR_SCAN);
    break;
  }
  case KEY_Cyrillic_ve:
  case KEY_d:{
    if(bso_locknode(&fa)) {
      rc=bso_flavor('D');
    }
    rc=bso_poll(&fa,rc);
    bso_unlocknode(&fa);
    sendcommand(QR_SCAN);
    break;
  }
  case KEY_Cyrillic_es:
  case KEY_c:{
    if(bso_locknode(&fa)) {
      rc=bso_flavor('C');
    }
    rc=bso_poll(&fa,rc);
    bso_unlocknode(&fa);
    sendcommand(QR_SCAN);
    break;
  }
  case KEY_Cyrillic_sha:
  case KEY_i:{
    if(bso_locknode(&fa)) {
      rc=bso_flavor('I');
    }
    rc=bso_poll(&fa,rc);
    bso_unlocknode(&fa);
    sendcommand(QR_SCAN);
    break;
  }
  case KEY_Cyrillic_ghe:
  case KEY_u:{
    bso_getstatus(&fa, &sts);
    if (sts.flags&Q_UNDIAL){ 
      sts.flags&=~Q_UNDIAL;
      sts.utime=0;
    }else{
      sts.flags|=Q_UNDIAL;
      sts.utime=t_set(cfgi(CFG_CLEARUNDIAL)*60);
    }
    bso_setstatus(&fa, &sts);
    sendcommand(QR_SCAN);
    break;
  }
  case KEY_Cyrillic_che:
  case KEY_x:{
    bso_getstatus(&fa, &sts);
    if (sts.flags&Q_WAITX){
      sts.flags&=~Q_WAITX;
      sts.htime=0;
    }else{
      sts.flags|=Q_WAITX;
      sts.htime=t_set(cfgi(CFG_WAITHRQ)*60);
    }
    bso_setstatus(&fa, &sts);
    sendcommand(QR_SCAN);
    break;
  }
  case KEY_Delete:{

    if(MBOX_CLICKED_YES==FXMessageBox::question(this,MBOX_YES_NO,"Killing outbound files","Kill outbound for %s?",ftnaddrtoa(&fa))) {
      if(bso_locknode(&fa)) {
	simulate_send(&fa);
	bso_unlocknode(&fa);
	sendcommand(QR_SCAN);
      }
    }
    break;
  }
  }
  return 0;
}

void PollDialog::show(){
  back_color=FXRGB(90,90,90);
  setBackColor(back_color);
  switch (flag){
  case 0: {
    poll_pollgroup->setText("Poll node");
    setTitle("Poll node");
    poll_fileslabel->hide();
    poll_filesfield->hide();
    poll_browse_button->hide();
    poll_hold_flavour->show();
    poll_normal_flavour->show();
    poll_direct_flavour->show();
    poll_crash_flavour->show();
    poll_imm_flavour->show();
    poll_hold_flavour->setCheck(FALSE);
    poll_normal_flavour->setCheck();
    poll_direct_flavour->setCheck(FALSE);
    poll_crash_flavour->setCheck(FALSE);
    poll_imm_flavour->setCheck(FALSE);
    break;
  }
  case 1: {
    poll_pollgroup->setText("FReq files");
    setTitle("FReq files");
    poll_fileslabel->show();
    poll_filesfield->show();
    poll_browse_button->hide();
    poll_hold_flavour->hide();
    poll_normal_flavour->hide();
    poll_direct_flavour->hide();
    poll_crash_flavour->hide();
    poll_imm_flavour->hide();
    break;
  }
  case 2: {
    poll_pollgroup->setText("Node");
    setTitle("Nodelist info");
    poll_fileslabel->hide();
    poll_filesfield->hide();
    poll_hold_flavour->hide();
    poll_browse_button->hide();
    poll_normal_flavour->hide();
    poll_direct_flavour->hide();
    poll_crash_flavour->hide();
    poll_imm_flavour->hide();
    break;
  }
  case 3: {
    poll_pollgroup->setText("Send files");
    setTitle("Send files");
    poll_fileslabel->show();
    poll_filesfield->show();
    poll_browse_button->show();
    poll_hold_flavour->show();
    poll_normal_flavour->show();
    poll_direct_flavour->show();
    poll_crash_flavour->show();
    poll_imm_flavour->show();
    poll_hold_flavour->setCheck(FALSE);
    poll_normal_flavour->setCheck();
    poll_direct_flavour->setCheck(FALSE);
    poll_crash_flavour->setCheck(FALSE);
    poll_imm_flavour->setCheck(FALSE);
    break;
  }
  }
  poll_addressfield->killFocus();
  poll_addressfield->setFocus();
  poll_addressfield->setText(nothing);
  poll_nodelistlabel->setText(nothing);
  FXDialogBox::show(PLACEMENT_SCREEN);
}

int getstyle(char *tmp){
  if ((strstr(tmp,"hydra"))||(strstr(tmp,"starting")))
    return 1;
  if ((strstr(tmp,"address:"))||(strstr(tmp,"sysop:")))
    return 2;
  if ((strstr(tmp,"calling"))||(strstr(tmp,"for us:"))||(strstr(tmp,"we have:"))||(strstr(tmp,"recv:"))||(strstr(tmp,"recd:"))||(strstr(tmp,"send:"))||(strstr(tmp,"sent:")))
    return 3;
  if ((strstr(tmp,"hanging"))||(strstr(tmp,"CONNECT"))||(strstr(tmp,"got"))||(strstr(tmp,"EMSI"))||(strstr(tmp,"aka:"))||(strstr(tmp,"mailer:"))||(strstr(tmp,"time:"))||(strstr(tmp,"  options:"))||(strstr(tmp,"resetting"))||(strstr(tmp,"poll"))||(strstr(tmp,"delayed")))
    return 4;
  if ((strstr(tmp,"total:"))||(strstr(tmp,"session with")))
    return 5;
  if ((strstr(tmp,"system:"))||(strstr(tmp,"from:"))||(strstr(tmp,"phone:"))||(strstr(tmp,"flags:")))
    return 6;
  if ((strstr(tmp,"error"))||(strstr(tmp,"interrupt"))||(strstr(tmp,"can't"))||(strstr(tmp,"failed")))
    return 7;
  return 0;
}

void QicoWindow::stylizeall(){
  long pos=0;
  char *tmp;
  tmp=(char*)malloc(255);
  
  while ((pos)<(mainlog->getLength())) {
    mainlog->extractText(tmp,pos,mainlog->lineEnd(pos)-pos);
    tmp[mainlog->lineEnd(pos)-pos]='\0';
    mainlog->changeStyle(pos+LOG_PREFIX_LEN,mainlog->lineEnd(pos)-pos-LOG_PREFIX_LEN,getstyle(tmp));
    pos=mainlog->nextLine(pos);
  }
  pos=0;
  while ((pos)<(masterlog->getLength())) {
    masterlog->extractText(tmp,pos,masterlog->lineEnd(pos)-pos);
    tmp[masterlog->lineEnd(pos)-pos]='\0';
    masterlog->changeStyle(pos+LOG_PREFIX_LEN,masterlog->lineEnd(pos)-pos-LOG_PREFIX_LEN,getstyle(tmp));
    pos=masterlog->nextLine(pos);
  }
  free(tmp);
}

// Print to Mainlog box
void QicoWindow::wlog(char *fmt,...){
  va_list args;
  char tmp[255];

  va_start(args,fmt);
  sprintf(tmp,"\n%s",fmt);
  fmt=strdup(tmp);
  vsprintf(tmp,fmt,args);
  va_end(args);

  mainlog->appendText(tmp,strlen(tmp));
  mainlog->changeStyle(mainlog->lineStart(mainlog->getLength())+LOG_PREFIX_LEN,mainlog->getLength()-mainlog->lineStart(mainlog->getLength())-LOG_PREFIX_LEN,getstyle(tmp));

  if (mainlog->isPosVisible(mainlog->lineStart(mainlog->lineStart(mainlog->getLength())-1)-1)) mainlog->makePositionVisible(mainlog->getLength());
}

void QicoWindow::wlog1(char *fmt,...){
  va_list args;
  char tmp[255];

  va_start(args,fmt);
  sprintf(tmp,"\n%s",fmt);
  fmt=strdup(tmp);
  vsprintf(tmp,fmt,args);
  va_end(args);

  masterlog->appendText(tmp,strlen(tmp));
  masterlog->changeStyle(masterlog->lineStart(masterlog->getLength())+LOG_PREFIX_LEN,masterlog->getLength()-masterlog->lineStart(masterlog->getLength())-LOG_PREFIX_LEN,getstyle(tmp));

  if (masterlog->isPosVisible(masterlog->lineStart(masterlog->lineStart(masterlog->getLength())-1)-1)) masterlog->makePositionVisible(masterlog->getLength());
}

char *timestr(time_t tim){
  static char ts[20];
  long int hr;
  if(tim<0) tim=0;
  hr=tim/3600;
  snprintf(ts, 10, "%02ld:%02ld:%02ld", hr, tim/60-hr*60, tim%60);
  return ts;
}


void QicoWindow::freshpfile(int b, int e, pfile_t *s, int act){
  char temp[255];
  
  if(s->cps<1) return;

  sprintf(temp, "\n%s file %d of %d\n\n%s %d / %d bytes\n(%s) %d cps",
	  act?"Sending":"Receiving",s->nf, s->allf,s->fname,s->foff,s->ftot,timestr((s->ftot-s->foff)/s->cps),s->cps);
  
  if (act){
    sendfile_label->setText(temp);
    sendbar->setProgress(s->foff*100/s->ftot);
  }
  else{
    recvfile_label->setText(temp);
    recvbar->setProgress(s->foff*100/s->ftot);
  }
  sprintf(temp, "Total: %d%c of %d%c\n(%s)",
	  SIZES(s->toff+s->foff), SIZEC(s->toff+s->foff),
	  SIZES(s->ttot), SIZEC(s->ttot),timestr((s->ttot-s->toff-s->foff)/s->cps));
  if (act){
    sendfile_total_label->setText(temp);
    send_t_bar->setProgress((s->toff+s->foff)*100/s->ttot);
  }
  else{
    recvfile_total_label->setText(temp);
    recv_t_bar->setProgress((s->toff+s->foff)*100/s->ttot);
  }
}

void QicoWindow::fresh_session_info(){
  char *temp;
  pfile_t *s,*r;
  s=&slot->send;
  r=&slot->recv;
  if ((!slot->session)||((s->cps<1)&&(r->cps<1))){
    recvfile_total_label->setText("Total: 0b of 0b\n(0:00:00)");
    sendfile_total_label->setText("Total: 0b of 0b\n(0:00:00)");
    recvbar->setProgress(0);
    recv_t_bar->setProgress(0);
    sendbar->setProgress(0);
    send_t_bar->setProgress(0);
    sendfile_label->setText("\nSending file 0 of 0\n\n*-none-* 0 / 0 bytes\n(0:00:00) 0 cps");
    recvfile_label->setText("\nReceiving file 0 of 0\n\n*-none-* 0 / 0 bytes\n(0:00:00) 0 cps");
    return;
  }
  temp=(char *)malloc(255);
  sprintf(temp,"Station: %s",slot->name);
  emsi_station_label->setText(temp);
  sprintf(temp,"Location: %s",SAFE(slot->city));
  emsi_location_label->setText(temp);
  sprintf(temp,"Sysop: %s", slot->sysop);
  emsi_sysop_label->setText(temp);
  sprintf(temp,"Flags: [%d] %s", slot->speed,SAFE(slot->flags));
  emsi_flags_label->setText(temp);
  sprintf(temp,"Phone: %s",slot->phone);
  emsi_phone_label->setText(temp);
  sprintf(temp,"AKA: %s", SAFE(slot->addrs));
  emsi_aka_label->setText(temp);
  sprintf(temp,slot->options&O_PWD?"[PWD]":nothing);
  emsi_pwd_label->setText(temp);
  sprintf(temp,slot->options&O_LST?"[LST]":nothing);
  emsi_lst_label->setText(temp);
  sprintf(temp,"Session timer: %s", timestr(time(NULL)-slot->start));
  statusbar_->setNormalText(temp);
  free(temp);
  freshpfile(1, 100, &slot->recv, 0);
  freshpfile(1, 100, &slot->send, 1);
}
  
char *strefresh(char **what, char *to){
  if(*what!=NULL) free(*what);
  *what=(char*)malloc(strlen(to)+1);
  if(*what) strcpy(*what, to);
  return *what;
}

qslot_t *addqueue(qslot_t **l){
  qslot_t **t, *p=NULL;
  for(t=l;*t;t=&((*t)->next)) p=*t;
  *t=(qslot_t *)malloc(sizeof(qslot_t));
  bzero(*t,sizeof(qslot_t));
  (*t)->prev=p;
  (*t)->n=p?p->n+1:1;
  return *t;
}

void killqueue(qslot_t **l){
  qslot_t *t;
  while(*l) {
    t=(*l)->next;
    xfree((*l)->addr);
    xfree(*l);
    *l=t;
  }
}

void QicoWindow::rescanOutbound(){
  char *temp1;
  int idx;
  bzero(buf, MSG_BUFFER);
  
  if (wlogflg){
    wlogflg--;
    if (strstr(towlog,"^cr^")) towlog=strstr(towlog,"^cr^")+4;
    while (wlogflg){
      idx=strlen(towlog)-strlen(strstr(towlog,"^cr^"));
      towlog[idx]='\0';
      wlog(towlog);
      towlog[idx]='^';
      if (strstr(towlog,"^cr^")) towlog=strstr(towlog,"^cr^")+4;
      wlogflg--;
    }
    wlog(towlog);
    wlogflg=0;
    *towlog=0;
  }
  
  rc=msgrcv(qipc_msg_, buf, MSG_BUFFER-1, 1, IPC_NOWAIT);
  if(rc>=13) {
    len=FETCH32(buf+4);
    pid=FETCH32(buf+8);
    type=buf[12];
    data_=strchr(buf+13,0)+1;
    data_[len]=0;
    //    fprintf(stdout,"type: %d\n",type);
    if(strcmp(buf+13, "master")) {
      if(type==QC_SLINE) {
	strefresh(&slot->status, data_);
	statusbar_->setNormalText(data_);
      }
      if(type==QC_LOGIT) {
	wlog(data_);
      }
      /*      if(type==QC_CHAT) {
	fprintf(stdout,"2 ok\n");
	fprintf(stdout,"chat: %s\n",data_);
	}*/
      if(type==QC_TITLE) {
	strefresh(&slot->header, data_);
	setTitle(data_);
      }
      if(type==QC_EMSID) {
	if(!len) {
	  xfree(slot->name);
	  xfree(slot->sysop);
	  xfree(slot->city);
	  xfree(slot->flags);
	  xfree(slot->phone);
	  xfree(slot->addrs);
	  slot->session=0;
	} else {
	  p=data_;
	  slot->speed=FETCH16(p);INC16(p);
	  slot->options=FETCH32(p);INC32(p);
	  slot->start=FETCH32(p);INC32(p);
	  strefresh(&slot->name, p);p+=strlen(p)+1;
	  strefresh(&slot->sysop, p);p+=strlen(p)+1;
	  strefresh(&slot->city, p);p+=strlen(p)+1;
	  strefresh(&slot->flags, p);p+=strlen(p)+1;
	  strefresh(&slot->phone, p);p+=strlen(p)+1;
	  strefresh(&slot->addrs, p);
	  slot->session=1;
	}	
	fresh_session_info();
      }
      if(type==QC_LIDLE) {
	if(&slot->session) {
	  slot->session=0;
	  bzero(&slot->recv, sizeof(pfile_t));
	  bzero(&slot->send, sizeof(pfile_t));
	  fresh_session_info();
	}
      }
      if(type==QC_SENDD) {
	if(!len) {
	  bzero(&slot->send, sizeof(pfile_t));
	} else {
	  char *p=data_;
	  
	  slot->session=1;
	  xfree(slot->send.fname);
	  
	  slot->send.foff=FETCH32(p);INC32(p);
	  slot->send.ftot=FETCH32(p);INC32(p);
	  slot->send.toff=FETCH32(p);INC32(p);
	  slot->send.ttot=FETCH32(p);INC32(p);
	  slot->send.nf=FETCH16(p);INC16(p);
	  slot->send.allf=FETCH16(p);INC16(p);
	  slot->send.cps=FETCH32(p);INC32(p);
	  slot->send.soff=FETCH32(p);INC32(p);
	  slot->send.stot=FETCH32(p);INC32(p);
	  slot->send.start=FETCH32(p);INC32(p);
	  slot->send.mtime=FETCH32(p);INC32(p);
	  
	  slot->send.fname=strdup(p);
	}
	fresh_session_info();
      }
      if(type==QC_RECVD) {
	if(!len) {
	  bzero(&slot->recv, sizeof(pfile_t));
	} else {
	  char *p=data_;
	  
	  slot->session=1;
	  xfree(slot->recv.fname);
	  
	  slot->recv.foff=FETCH32(p);INC32(p);
	  slot->recv.ftot=FETCH32(p);INC32(p);
	  slot->recv.toff=FETCH32(p);INC32(p);
	  slot->recv.ttot=FETCH32(p);INC32(p);
	  slot->recv.nf=FETCH16(p);INC16(p);
	  slot->recv.allf=FETCH16(p);INC16(p);
	  slot->recv.cps=FETCH32(p);INC32(p);
	  slot->recv.soff=FETCH32(p);INC32(p);
	  slot->recv.stot=FETCH32(p);INC32(p);
	  slot->recv.start=FETCH32(p);INC32(p);
	  slot->recv.mtime=FETCH32(p);INC32(p);
	  
	  slot->recv.fname=strdup(p);
	}
	fresh_session_info();
      }
      
    } else {
      if(type==QC_SLINE) {
	strefresh(&m_status, data_);
	statusbar->setNormalText(data_);
      }
      if(type==QC_TITLE) {
	queuegroup->setText(data_);
	strefresh(&m_header, data_);
      }
      if(type==QC_LOGIT) {
	wlog1(data_);
      }
      if(type==QC_QUEUE) {
	if(!len) {
	  count=queuebox->getCurrentItem();
	  if (count<0) count=0;
	  vcount=0;
	  for (int i=0;i<queuebox->getNumItems();i++){
	      if (queuebox->isItemVisible(i)) { vcount=i; }
	    }
	  queuebox->clearItems();
	  killqueue(&queue);
	} else {
	  char *p=data_;
	  qslot_t *q=addqueue(&queue);
	  
	  q->mail=FETCH32(p);INC32(p);
	  q->files=FETCH32(p);INC32(p);
	  q->flags=FETCH32(p);INC32(p);
	  q->tryes=FETCH16(p);INC16(p);
	  q->addr=strdup(p);
	  temp1=(char *)malloc(64);
	  sprintf(temp1,"%s",q->addr);
	  for (int i=strlen(q->addr);i<18;i++) strcat(temp1," ");
	  sscat(temp1,q->mail);
	  for (int i=strlen(temp1);i<25;i++) strcat(temp1," ");
	  sscat(temp1,q->files);
	  sprintf(temp1+strlen(temp1),"%5d",q->tryes);
	  int l=1;
	  sprintf(temp1+strlen(temp1),"%1c",' ');
	  for(int k=0;k<Q_MAXBIT;k++) {
	    sprintf(temp1+strlen(temp1),"%c",(q->flags&l) ? qflgs[k] : '.');
	    l=l<<1;
	  }
	  if (count<queuebox->getNumItems()){
	      if (vcount<=queuebox->getNumVisible()) queuebox->makeItemVisible(vcount-1);
	      else queuebox->makeItemVisible(vcount);
	      queuebox->setCurrentItem(count);
	    }
	  else{
	      queuebox->setCurrentItem(queuebox->getNumItems()-1);
	    }
	  if (queuebox->getNumItems()) queuebox->removeItem(queuebox->getNumItems()-1);
	  queuebox->insertItem(queuebox->getNumItems(),temp1);
	  queuebox->insertItem(queuebox->getNumItems()," ");
	  free(temp1);
	}
      }
    }
  }
}

long QicoWindow::onCmdTimer(FXObject*,FXSelector,void*){
  rescanOutbound();
  getApp()->addTimeout(1,this,ID_TIMER);
  return 0;
}

long QicoWindow::onCmdQuit(FXObject*,FXSelector,void*){
  msgctl(qipc_msg_, IPC_RMID, 0);
  getApp()->exit(0);
  return 0;
}

long QicoWindow::onCmdPoll(FXObject*,FXSelector,void*){
  flag=0;
  polldialog->show();
  return 0;
}

long QicoWindow::onCmdSend(FXObject*,FXSelector,void*){
  flag=3;
  polldialog->show();
  return 0;
}

long QicoWindow::onCmdFreq(FXObject*,FXSelector,void*){
  flag=1;
  polldialog->show();
  return 0;
}

long QicoWindow::onCmdNodelist(FXObject*,FXSelector,void*){
  flag=2;
  polldialog->show();
  return 0;
}

long QicoWindow::onCmdSkip(FXObject*,FXSelector,void*){
  int rc;
  char p[MAX_PATH];
  if ((slot->session)&&(slot->recv.fname)){
    if (slot->options&O_PWD){
      snprintf(p, MAX_PATH, "%s/tmp/%s", PROT_INBOUND,slot->recv.fname);
    }else snprintf(p, MAX_PATH, "%s/tmp/%s", cfgs(CFG_INBOUND),slot->recv.fname);
    rc=unlink(p);
    
    if (rc<0){
      wlog("Cannot remove %s...",p);
    }
  }
  else wlog("There is no receiving process...");
  skipbutton->killFocus();
  return 0;
}  

void ipctimeout(int sig){
  signal(SIGALRM, SIG_DFL);
  fprintf(stderr,"got timeout\n");
}

int getanswer(){
  char buf[MSG_BUFFER];                                                   
  int rc;
  
  signal(SIGALRM, ipctimeout);
  alarm(1);
  rc=msgrcv(qipc_msg1, buf, MSG_BUFFER-1, getpid(), 0);
  if(rc<4) return 1;
  if(buf[4]) fprintf(stderr, "%s\n", buf+5);
  signal(SIGALRM, SIG_DFL);
  alarm(0);
  return buf[4];
}
char *xstrcpy(char *dst, char *src, size_t size){
  char *d;
  int n;
  if(!src) return dst;
  if(!dst) return NULL;
  if(size) {
    d = dst;
    n = size - 1;
    while(n-- && *src) *d++ = *src++;
    n += 2;
    while(n--) *d++ = 0;
  }
  return dst;
}

int openqueue(){
  if((qipc_key1=ftok(QIPC_KEY,QR_MSGQ))<0) {
    fprintf(stderr, "can't get key\n");
    return 0;
  }
  if((qipc_msg1=msgget(qipc_key1, 0666))<0) {
    fprintf(stderr, "can't get message queue, may be there's no daemon: %s\n",strerror(errno));
    return 0;
  }
  return 1;
}

char *infostrs[]={
  "%sAddress: %s",
  "%s\nStation: %s",
  "%s\nPlace: %s",
  "%s\nSysop: %s",
  "%s\nPhone: %s",
  "%s\nFlags: %s",
  "%s\nSpeed: %s",
};

time_t gmtoff(time_t tt){
  struct tm lt;
#ifndef TM_HAVE_GMTOFF
  struct tm gt;
  time_t offset;
  lt=*localtime(&tt);
  gt=*gmtime(&tt);
  offset=gt.tm_yday-lt.tm_yday;
  if (offset > 1) offset=-24;
  else if (offset < -1) offset=24;
  else offset*=24;
  offset+=gt.tm_hour-lt.tm_hour;
  offset*=60;
  offset+=gt.tm_min-lt.tm_min;
  offset*=60;
  offset+=gt.tm_sec-lt.tm_sec;
  return -offset;
#else
  lt=*localtime(&tt);
  return lt.tm_gmtoff;
#endif
}


long PollDialog::onCmdAddrEnter(FXObject*,FXSelector,void* ptr){
  FXEvent *event=(FXEvent*)ptr;
  switch (event->code){
  case KEY_Return: {
    switch (flag){
    case 1: {poll_filesfield->setFocus(); break;}
    default: {onCmdDoPoll(this,0,0); break;}
    }
  } 
  default:{
    FXString stmp;
    int rc;
    time_t tm=time(NULL);
    long tz=gmtoff(tm)/3600;
    char *temp,*pt,*u;
    ftnaddr_t fa;
    ninfo_t *rnode;
    temp=(char*)malloc(255);
    stmp=poll_addressfield->getText();
    sprintf(temp,"%s",stmp.text());
    if (!parseftnaddr(temp,&fa,&DEFADDR,0)) {poll_nodelistlabel->setText("Can't parse address..."); break;}
    rnode=(ninfo_t*)calloc(1,sizeof(ninfo_t));
    rc=query_nodelist(&fa,cfgs(CFG_NLPATH),&rnode);
    switch (rc){
    case 0: {
      if (rnode) {
	sprintf(temp,"Address: %s\nStation: %s\nPlace: %s\nSysop: %s\nPhone: %s\nFlags: %s\nSpeed: %d",ftnaddrtoa(&fa),rnode->name,rnode->place,rnode->sysop,rnode->phone,rnode->flags,rnode->speed);
	u=strdup(rnode->flags);
	while((pt=strsep(&u, ","))) {
	  if(!strcmp(pt,"CM")) {
	    sprintf(temp,"%s\nWkTime: 00:00-24:00",temp);
	    break;
	  }
	  if(pt[0]=='T' && pt[3]==0) {
	    sprintf(temp,"%s\nWkTime: %02ld:%02d-%02ld:%02d",temp,
		    (toupper(pt[1])-'A'+tz)%24,
		    islower((int)pt[1]) ? 30:0,
		    (toupper(pt[2])-'A'+tz)%24,
		    islower((int)pt[2]) ? 30:0);
	    break;
	  }
	}

	poll_nodelistlabel->setText(temp);
	nlkill(&rnode);
      }else poll_nodelistlabel->setText("Address is not found in nodelist...");
      break;
    }
    case 1: {poll_nodelistlabel->setText("can't query nodelist, index error"); break;}
    case 2: {poll_nodelistlabel->setText("can't query nodelist, nodelist error"); break;}
    case 3: {poll_nodelistlabel->setText("index is older than the list, need recompile"); break;}
    default: {poll_nodelistlabel->setText("nodelist query error!"); break;}
    }
    free(temp);
    /* 
    char buf[MSG_BUFFER], *p, *u, *temp;
    char *pt;
    if (!(openqueue())) break;
    *((int *)buf)=1;                                                        
    *((int *)buf+1)=getpid();                                               
    buf[8]=QR_INFO;
    xstrcpy(buf+9,temp, MSG_BUFFER-9);
    msgsnd(qipc_msg1,buf,strlen(temp)+10, 0);
    signal(SIGALRM, ipctimeout);
    alarm(5);
    rc=msgrcv(qipc_msg1, buf, MSG_BUFFER-1, getpid(), 0);
    if(rc<4) {
      poll_nodelistlabel->setText(nothing);
      break;
    }
    if(buf[4]) {
      poll_nodelistlabel->setText(nothing);
    } else {
      bzero(temp,sizeof(char));
      for(p=buf+5,rc=0;strlen(p);rc++) {
	sprintf(temp,infostrs[rc],temp,p);
	u=p;p+=strlen(p)+1;
	if(rc==5){
	  while((pt=strsep(&u, ","))) {
	    if(!strcmp(pt,"CM")) {
	      sprintf(temp,"%s\nWkTime: 00:00-24:00",temp);
	      break;
	    }
	    if(pt[0]=='T' && pt[3]==0) {
	      sprintf(temp,"%s\nWkTime: %02ld:%02d-%02ld:%02d",temp,
		      (toupper(pt[1])-'A'+tz)%24,
		      islower((int)pt[1]) ? 30:0,
		      (toupper(pt[2])-'A'+tz)%24,
		      islower((int)pt[2]) ? 30:0);
	      break;
	    }
	  }
	}
      }
      poll_nodelistlabel->setText(temp);
    }
    free(temp);
    signal(SIGALRM, SIG_DFL);
    alarm(0);
    }*/
  }
  }
  return 0;
}

int sendcommand (int command){
  char buf[MSG_BUFFER];
  if (openqueue()){
    *((int *)buf)=1;                                                        
    *((int *)buf+1)=getpid();                                               
    buf[8]=command;
    msgsnd(qipc_msg1, buf, 9, 0);
    return getanswer();
  }else return 1;
}

//  long PollDialog::onCmdDoPoll(FXObject*,FXSelector,void*)
//  {
//    char buf[MSG_BUFFER], temp[MSG_BUFFER], files[MSG_BUFFER];
//    FXString stmp;
//    if (!(openqueue())) return 1;
//    stmp=poll_addressfield->getText();
//    sprintf(temp,"%s",stmp.text());
//    *((int *)buf)=1;                                                        
//    *((int *)buf+1)=getpid();                                               
//    switch (flag)
//      {
//      case 0: {
//        buf[8]=QR_POLL;
//        do
//  	{
//  	  xstrcpy(buf+9, temp, MSG_BUFFER-9);
//  	  if (poll_hold_flavour->getCheck()) buf[10+strlen(buf+9)]='H';
//  	  if (poll_normal_flavour->getCheck()) buf[10+strlen(buf+9)]='N';
//  	  if (poll_direct_flavour->getCheck()) buf[10+strlen(buf+9)]='D';
//  	  if (poll_crash_flavour->getCheck()) buf[10+strlen(buf+9)]='C';
//  	  if (poll_imm_flavour->getCheck()) buf[10+strlen(buf+9)]='I';
//  	  msgsnd(qipc_msg1, buf, strlen(temp)+11, 0);
//  	}
//        while (strstr(temp," ")?sprintf(temp,"%s",strstr(temp," ")+1):0);
//        break;
//      }
//      case 1: {
//        buf[8]=QR_REQ;
//        stmp=poll_filesfield->getText();
//        sprintf(files,"%s",stmp.text());
//        break;
//      }
//      }
//    getApp()->stopModal(this,TRUE);
//    hide();
//    return getanswer();
//  }

long PollDialog::onCmdDoPoll(FXObject*,FXSelector,void*){
  char temp[MSG_BUFFER], *files;
  int rc=0,idx=0;
  ftnaddr_t fa;
  FXString stmp;
  files=(char*)malloc(MSG_BUFFER);
  stmp=poll_addressfield->getText();
  sprintf(temp,"%s",stmp.text());
  if (strlen(temp)){
    switch (flag){
    case 0: {
      do {
	if(!parseftnaddr(temp, &fa, &DEFADDR, 0)) {
	  sprintf(towlog,"%s^cr^                can't parse address '%s'!", towlog, temp);
	  wlogflg++;
	  break;
	}
	if(bso_locknode(&fa)) {
	  if (poll_hold_flavour->getCheck()) rc=bso_flavor('H');
	  if (poll_normal_flavour->getCheck()) rc=bso_flavor('N');
	  if (poll_direct_flavour->getCheck()) rc=bso_flavor('D');
	  if (poll_crash_flavour->getCheck()) rc=bso_flavor('C');
	  if (poll_imm_flavour->getCheck()) rc=bso_flavor('I');
	  if(rc==0) {
	    sprintf(towlog,"                unknown flavour");
	    wlogflg++;
	    break;
	  }
	  sprintf(towlog,"%s^cr^                poll for %s, flavor %d", towlog, ftnaddrtoa(&fa),rc);
	  wlogflg++;
	  //	  qsendpkt(QC_CHAT,QLNAME,towlog,strlen(towlog)+1);
	  //	  fprintf(stdout,"1 ok\n");
	  rc=bso_poll(&fa,rc);
	  bso_unlocknode(&fa);
	  sendcommand(QR_SCAN);
	} else {
	  sprintf(towlog,"%s^cr^                can't create poll for %s!", towlog, ftnaddrtoa(&fa));
	  wlogflg++;
	}
      }
      while (strstr(temp," ")?sprintf(temp,"%s",strstr(temp," ")+1):0);
      
      break;
    }
    case 1: {
      slist_t *sl;
      if(!parseftnaddr(temp, &fa, &DEFADDR, 0)) {
	sprintf(towlog,"%s^cr^                can't parse address '%s'!", towlog, temp);
	wlogflg++;
	break;
      }
      stmp=poll_filesfield->getText();
      sprintf(files,"%s",stmp.text());
      if (strlen(files)) {
	if(bso_locknode(&fa)) {
	  sl=NULL;
	  do {
	    if (strchr(files,' ')) {
	      idx=strlen(files)-strlen(strchr(files,' '));
	      files[idx]='\0';
	    }
	    sprintf(towlog,"%s^cr^                requested '%s' from %s", towlog, files, ftnaddrtoa(&fa));
	    wlogflg++;
	    slist_add(&sl,files);
	    if (idx) files[idx]=' ';
	    idx=0;
	  }
	  while (strstr(files," ")?sprintf(files,"%s",strstr(files," ")+1):0);
	  rc=bso_request(&fa, sl);
	  slist_kill(&sl);
	  bso_unlocknode(&fa);
	  sendcommand(QR_SCAN);
	} else {
	  sprintf(towlog,"%s^cr^                can't lock node %s!", towlog, ftnaddrtoa(&fa));
	  wlogflg++;
	}
      }
    
    break;
  }
    case 3: {
      if(!parseftnaddr(temp, &fa, &DEFADDR, 0)) {
	sprintf(towlog,"%s^cr^                can't parse address '%s'!", towlog, temp);
	wlogflg++;
	break;
      }
      if(bso_locknode(&fa)) {
	if (poll_hold_flavour->getCheck()) rc=bso_flavor('H');
	if (poll_normal_flavour->getCheck()) rc=bso_flavor('N');
	if (poll_direct_flavour->getCheck()) rc=bso_flavor('D');
	if (poll_crash_flavour->getCheck()) rc=bso_flavor('C');
	if (poll_imm_flavour->getCheck()) rc=bso_flavor('I');
	slist_t *sl;
	stmp=poll_filesfield->getText();
	sprintf(files,"%s",stmp.text());
	if (strlen(files)) {
	  sl=NULL;
	  do {
	    if (strchr(files,' ')) {
	      idx=strlen(files)-strlen(strchr(files,' '));
	      files[idx]='\0';
	    }
	    sprintf(towlog,"%s^cr^                attached '%s' to %s", towlog, files, ftnaddrtoa(&fa));
	    wlogflg++;
	    slist_add(&sl,files);
	    if (idx) files[idx]=' ';
	    idx=0;
	  }
	  while (strstr(files," ")?sprintf(files,"%s",strstr(files," ")+1):0);
	  rc=bso_attach(&fa, rc, sl);
	  slist_kill(&sl);
	  bso_unlocknode(&fa);
	  sendcommand(QR_SCAN);
	} else {
	  sprintf(towlog,"%s^cr^                can't attach files for %s!", towlog, ftnaddrtoa(&fa));
	  wlogflg++;
	}
      }
    }
    }
  }
  free(files);
  getApp()->stopModal(this,TRUE);
  hide();
  //  destroy();
  return 0;
}

long QicoWindow::onCmdReread(FXObject*,FXSelector,void*){
  sendcommand(QR_CONF);
  rereadbutton->killFocus();
  return 0;
}  

long QicoWindow::onCmdRescan(FXObject*,FXSelector,void*){
  sendcommand(QR_SCAN);
  rescanbutton->killFocus();
  return 0;
}

long PollDialog::onCmdFilesEntered(FXObject*,FXSelector,void*){
  onCmdDoPoll(this,0,0);
  return 0;
}

long PollDialog::onCmdFileBrowse(FXObject*,FXSelector,void*){
  char tmp[1024]="";
  FXString *files=FXFileDialog::getOpenFilenames(this,"Send file","~/");
  if (files){
    for(int i=0; !files[i].empty(); i++){                                       
      sprintf(tmp,"%s%s ",tmp,files[i].text());                              
    }                                                                         
    delete [] files;
    tmp[strlen(tmp)-1]='\0';
    poll_filesfield->setText(tmp);
  }
  return 0;
}

int main(int argc,char **argv){
  readconfig(FILE_CONFIG);
  if(!bso_init(cfgs(CFG_OUTBOUND), cfgal(CFG_ADDRESS)->addr.z)) {         
    fprintf(stdout,"can't init BSO: %s",cfgs(CFG_OUTBOUND));
    exit(1);                                                        
  }                                                                       
  if((qipc_key_=ftok(QIPC_KEY,QC_MSGQ))<0) {
    fprintf(stderr, "can't create ipc key\n");
    return 0;
  }
  
  if((qipc_msg_=msgget(qipc_key_, 0666 | IPC_CREAT | IPC_EXCL))<0) {
    fprintf(stderr, "can't create message queue (may be there's another qcc/xqcc running or died?)\nfor more information read `man ipcs` and `man ipcrm`\n");
    return 0;
  }
  slot=(slot_t*)malloc(sizeof(slot_t));
  bzero(slot, sizeof(slot_t));
  slot->session=0;
  towlog=(char*)malloc(255);  
  wlogflg=0;
  FXApp application("xqcc","by pryamognev");
  application.init(argc,argv);
  new QicoWindow(&application);
  application.create();
  
  application.run();
  bso_done();
  return 0;
}
